package com.chinaitop.agile.controller;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.agile.model.DataCrkywTzdxxFlt001;
import com.chinaitop.agile.service.TzdxxService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping(value="/agile/tzdxx")
@Api(value= "TzdxxController", description = "通知单信息")

public class TzdxxController {

	@Resource
    private TzdxxService tzdxxService;
	
	/**
     * 根据主表的通知单编号 获取子表的数据
     * @param pageNum 页码
     * @param pageSize 每页显示条数
     * @return
     */
	@RequestMapping(value="/getList", produces = MediaType.APPLICATION_JSON_VALUE, method=RequestMethod.GET)
	@ApiOperation(value="获取提货单列表信息", notes = "查询数据列表，支持分页")
	@ApiImplicitParams({
		@ApiImplicitParam(name = "pageNum", value = "页码", paramType = "query"),
		@ApiImplicitParam(name = "pageSize", value = "每页条数", paramType = "query")
	})
    public List<DataCrkywTzdxxFlt001> getList(Integer tzdId,Integer htId,Integer orgId,Integer houseId,Integer warehouseId) {
        List<DataCrkywTzdxxFlt001> list = tzdxxService.queryByExample(tzdId,htId,orgId,houseId,warehouseId);    
        return list;
    }
    
    
	
}
