package com.chinaitop.agile.mapper;

import java.util.List;
import java.util.Map;

public interface CrkRecordMapper {

	/**
	 * 查询汽车出入库记录 
	 * 
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryQcCrkrecord(Map<String, Object> map);

	/**
	 * 代储点查询汽车出入库记录
	 *
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryAgentQcCrkrecord(Map<String, Object> map);

	/**
	 * 查询火车出入库记录
	 * 
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryHcCrkrecord(Map<String, Object> map);

	/**
	 * 代储点查询火车出入库记录
	 *
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryAgentHcCrkrecord(Map<String, Object> map);

	/**
	 * 按条件查询出入库质检信息
	 * 
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryJyxx(Map<String, Object> map);

	/**
	 * 按条件查询入库称重信息
	 * 
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryRkCzxx(Map<String, Object> map);

	/**
	 * 按条件查询出库称重信息
	 * 
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryCkCzxx(Map<String, Object> map);

	/**
	 * 出入库监管统计查询列表
	 * @param map
	 * @return
	 */
    List<Map<String,Object>> queryCycleFoodCount(Map<String, Object> map);

	/**
	 * 查询火车出入库质检信息
	 * @param conditionMap
	 * @return
	 */
    Map<String, Object> queryTrainJyxx(Map<String, Object> conditionMap);

	/**
	 * 查询火车出入库称重信息
	 *
	 * @param conditionMap 查询条件
	 * @return
	 */
	Map<String,Object> queryTrainCzxx(Map<String, Object> conditionMap);

	/**
	 * 查询入库信息--省级平台调用
	 *
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryRkData(Map<String, Object> map);

	/**
	 * 查询出库信息--省级平台调用
	 *
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryCkData(Map<String, Object> map);

	/**
	 * 按条件查询出入库质检信息
	 * 
	 * @param map 查询条件
	 * @return
	 */
	List<Map<String, Object>> queryJyxxNew(Map<String, Object> conditionMap);

	/**
	 * 查询粮食品种对应的指标项出入库字典ID
	 * @param conditionMap
	 * @return
	 */
	Map<String, Object> queryDataLspz(Map<String, Object> conditionMap);
}
