package com.chinaitop.agile.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.agile.model.BusinessScedule;


public interface BusinessSceduleService {

    /**
     * 通过多个计划id,获取这多个计划的出入库类型，出库总数量，入库总数量.
     * @param planIds
     * @return
     */
    List<BusinessScedule> getPlanSceduleInPlanId(String planIds);
    
    /**
     * 通过多个合同id,获取这多个合同的出入库类型，出库总数量，入库总数量.
     * @param planIds
     * @return
     */
    List<BusinessScedule> getContractSceduleInContractId(String contractIds);
    
    /**
     * 通过多个通知单id,获取这多个通知单的出入库类型，出库总数量，入库总数量.
     * @param planIds
     * @return
     */
    List<BusinessScedule> getNoticeSceduleInNoticeId(String noticeIds);

    /**
     * 根据粮库业务管理中出入库通知单id,修改出入库系统中，通知单状态. 
     * 修改出入库表  data_crkyw_tzdxx_default中tzdh等于 这边的 通知单id获取到DataID 
     * 通过DataID 链接 fl_bill_relation 修改字段FLOWSTATUS
     * @param paramMap 通知单id. 通知单状态.
     */
    void updateNoticeStatus(Map<String, Object> paramMap);
    
    /**
     * 通过多个到站中转合同id,获取这多个合同的出入库类型，出库总数量，
     * @param noticeIds
     * @return
     */
	List<BusinessScedule> getDzContractSceduleInContractId(String contractIds);

	/**
     * 通过多个发运中转合同id,获取这多个合同的出入库类型，出库总数量，
     * @param noticeIds
     * @return
     */
	List<BusinessScedule> getFyContractSceduleInContractId(String contractIds);
	
	List<BusinessScedule> getThdInNumber(String thdNumbers);

}
