package com.chinaitop.agile.service.impl;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;

import com.chinaitop.agile.mapper.DataKcglFcbgzDefaultMapper;
import com.chinaitop.agile.model.DataKcglFcbgzDefault;
import com.chinaitop.agile.model.DataKcglFcbgzDefaultExample;
import com.chinaitop.agile.service.DataKcglFcbgzDefaultService;
import com.chinaitop.utils.ParameterUtil;

@Service
public class DataKcglFcbgzDefaultServiceImpl implements DataKcglFcbgzDefaultService {

	@Resource
	private DataKcglFcbgzDefaultMapper mapper;

	public DataKcglFcbgzDefault findConditionMax(DataKcglFcbgzDefault fcbgz) throws Exception {
		DataKcglFcbgzDefault obj = null;
		DataKcglFcbgzDefaultExample example = new DataKcglFcbgzDefaultExample();
		DataKcglFcbgzDefaultExample.Criteria criteria = example.createCriteria();
		criteria.andChEqualTo(fcbgz.getCh());
		criteria.andHwhEqualTo(fcbgz.getHwh());
		criteria.andPzEqualTo(fcbgz.getPz());
		criteria.andHwxzEqualTo(fcbgz.getHwxz());
		criteria.andUnitidEqualTo(fcbgz.getUnitid());

		String data = ParameterUtil.date2string(fcbgz.getRqs());
		Date start_rq = ParameterUtil.string2datetime(data +" 00:00:00");
		Date end_rq = ParameterUtil.string2datetime(data +" 23:59:59");
		criteria.andRqBetween(start_rq, end_rq);

		example.setOrderByClause("rq desc");

		List<DataKcglFcbgzDefault> list = mapper.selectByExample(example);
		if (null != list && list.size() > 0) {
			obj = list.get(0);
		}
		
		return obj;
	}

	@Override
	public List<DataKcglFcbgzDefault> findByList(DataKcglFcbgzDefaultExample example) throws Exception {
		return mapper.selectByExample(example);
	}

	@Override
	public List<Map<String, Object>> findByListNew(Map<String, Object> param_map) throws Exception {
		return mapper.selectByExampleNew(param_map);
	}

	@Override
	public DataKcglFcbgzDefault findByIdFcbgzData(String id) {
		return mapper.selectByPrimaryKey(id);
	}

	@Override
	public Map<String, Object> queryCrkJyxx(String id) {
		/* 返回结果  */
		Map<String, Object> result_map = new HashMap<String, Object>();

		/* 查询条件  */
		Map<String, Object> conditionMap = new HashMap<String, Object>();
		conditionMap.put("id", id);

		/* 查询化验项信息 */
		List<Map<String, Object>> list = mapper.queryCrkJyxx(conditionMap);

		/* 查询对应品种的化验项的顶级ID */
		String lspz = "";
		if (null != list && list.size() > 0) {
			result_map.put("zjxx", list);
			lspz = ObjectUtils.toString(list.get(0).get("lspz"), "");
			conditionMap.put("lspz", lspz);
			Map<String, Object> lspzid_map = mapper.queryDataLspz(conditionMap);
			result_map.put("parentId", ObjectUtils.toString(lspzid_map.get("enumitemid"), ""));
		} else {
			result_map.put("zjxx", "");
			result_map.put("parentId", "");
		}
		return result_map;
	}

	@Override
	public List<Map<String, Object>> queryRkZsList(Map<String, Object> param_map) {
		return mapper.queryRkZsList(param_map);
	}

}
