package com.chinaitop.agile.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.agile.feignService.BasicEnumFeignService;
import com.chinaitop.agile.feignService.BasicStorehouseFeignService;
import com.chinaitop.agile.feignService.BasicWarehouseFeignService;
import com.chinaitop.agile.mapper.DataKcglFcbgzDefaultMapper;
import com.chinaitop.agile.mapper.DataKcglKcswDefaultMapper;
import com.chinaitop.agile.mapper.DataKcglXckcDefaultMapper;
import com.chinaitop.agile.model.*;
import com.chinaitop.agile.model.DataKcglKcswDefaultExample.Criteria;
import com.chinaitop.agile.service.DataKcglFcbgzDefaultService;
import com.chinaitop.agile.service.KcswService;
import com.chinaitop.agile.utils.ParameterUtil;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import org.apache.commons.lang.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Font;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.io.BufferedOutputStream;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.*;

@Service
public class KcswServiceImpl implements KcswService{

	@Resource
	private DataKcglKcswDefaultMapper dataKcglKcswDefaultMapper;
	@Resource
	private DataKcglXckcDefaultMapper dataKcglXckcDefaultMapper;
	@Resource
	private DataKcglFcbgzDefaultMapper dataKcglFcbgzDefaultMapper;
	@Resource
	private DataKcglFcbgzDefaultService fcbgzService;
	@Resource
	private BasicEnumFeignService basicEnumFeignService;
	@Resource
	private BasicStorehouseFeignService basicStorehouseFeignService;
	@Resource
	private BasicWarehouseFeignService basicWarehouseFeignService;

	public Map<String, Object> queryByExample(Integer orgId) throws Exception {
		/* 返回数据对象 */
		Map<String, Object> modelMap = new HashMap<String, Object>();
		
		/* 当前年份  */
		int this_year = Integer.parseInt(ParameterUtil.getSysDateYear());

		/* 封装年份  */
		String []year_num = new String[5];
		year_num[0] = this_year - 4 + "";
		year_num[1] = this_year - 3 + "";
		year_num[2] = this_year - 2 + "";
		year_num[3] = this_year - 1 + "";
		year_num[4] = this_year + "";
		modelMap.put("years", year_num);

		/* 查询库存数量表数据  */
		DataKcglKcswDefaultExample example = new DataKcglKcswDefaultExample();
		Criteria criteria = example.createCriteria();
		criteria.andUnitidEqualTo(orgId+"");
		List<DataKcglKcswDefault> list = dataKcglKcswDefaultMapper.selectByExample(example);

		String pz = "";
		String year = "0";
		DecimalFormat obj = new DecimalFormat(".0000");  // 保留4位小数
		String sumCkslFormat = "";
		BigDecimal sumCksls = null;
		
		double []_xiaomai = new double[5];
		double []_yumi = new double[5];
		double []_daogu = new double[5];
		double []_dadou = new double[5];
		for (int i = 0; i < year_num.length; i++) {
			double sumXiaomaikcsl = 0d; //小麦
			double sumYumikcsl = 0d; //玉米
			double sumDadoukcsl = 0d; //大豆
			double sumDaogukcsl = 0d; //稻谷
			if (null != list && list.size() > 0) {
				for (DataKcglKcswDefault kcsw_obj : list) {
					DataKcglFcbgzDefaultExample fcbgz_example = new DataKcglFcbgzDefaultExample();
					DataKcglFcbgzDefaultExample.Criteria fcbgz_criteria = fcbgz_example.createCriteria();
					fcbgz_criteria.andUnitidEqualTo(kcsw_obj.getUnitid());
					fcbgz_criteria.andChEqualTo(kcsw_obj.getCh());
					fcbgz_criteria.andHwhEqualTo(kcsw_obj.getHwh());
					fcbgz_criteria.andSrslGreaterThan(0d);//收入数量大于0
					fcbgz_example.setOrderByClause(" rq DESC");
					//给生产年份赋值
					List<DataKcglFcbgzDefault> fcbgz_list = dataKcglFcbgzDefaultMapper.selectByExample(fcbgz_example);
					Integer scnf = 0;
					if (null != fcbgz_list && fcbgz_list.size() > 0) {
						scnf = Integer.parseInt(ObjectUtils.toString(fcbgz_list.get(0).getScnf(), "0"));
					}

					pz = kcsw_obj.getPz();
					if (null == scnf || "".equals(scnf)) {
						scnf = 0;
					}
					/* 获取年份的字典值 */
					String strResult = basicEnumFeignService.getEnumData(scnf);
					if (null != strResult && !"".equals(strResult)) {
						JSONObject enum_obj = JSONObject.parseObject(strResult);
						year = enum_obj.get("enumname")+"";//年份字典
					} else {
						year = "0";
					}
					if (year.equals(year_num[i]) && "3164".equals(pz)) {//这个年份小麦的数据
						sumXiaomaikcsl = sumXiaomaikcsl + kcsw_obj.getKcsl();
					} else if (year.equals(year_num[i]) && "3165".equals(pz)) {//这个年份玉米的数据
						sumYumikcsl = sumYumikcsl + kcsw_obj.getKcsl();
					} else if (year.equals(year_num[i]) && "3166".equals(pz)) {//这个年份稻谷的数据
						sumDaogukcsl = sumDaogukcsl + kcsw_obj.getKcsl();
					} else if (year.equals(year_num[i]) && "2777".equals(pz)) {//这个年份大豆的数据
						sumDadoukcsl = sumDadoukcsl + kcsw_obj.getKcsl();
					}
				}
			}
			//处理小麦
			sumCkslFormat = obj.format(sumXiaomaikcsl/1000);
			sumCksls = new BigDecimal(sumCkslFormat);
			_xiaomai[i] = Double.parseDouble(sumCksls+"");

			//处理玉米
			sumCkslFormat = obj.format(sumYumikcsl/1000);
			sumCksls = new BigDecimal(sumCkslFormat);
			_yumi[i] = Double.parseDouble(sumCksls+"");

			//处理稻谷
			sumCkslFormat = obj.format(sumDaogukcsl/1000);
			sumCksls = new BigDecimal(sumCkslFormat);
			_daogu[i] = Double.parseDouble(sumCksls+"");

			//处理大豆
			sumCkslFormat = obj.format(sumDadoukcsl/1000);
			sumCksls = new BigDecimal(sumCkslFormat);
			_dadou[i] = Double.parseDouble(sumCksls+"");
		}

		modelMap.put("xiaomai", _xiaomai);
		modelMap.put("yumi", _yumi);
		modelMap.put("daogu", _daogu);
		modelMap.put("dadou", _dadou);

		return modelMap;
	}

	public Map<String, Object> queryByDj(Integer orgId) throws Exception {
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("orgId", orgId);
		List<DataKcswScedule> countByDj = dataKcglKcswDefaultMapper.countByDj(map);
		Map<String, Object> modelMap = new HashMap<String, Object>();
		double yi = 0d;
		double er = 0d;
		double san = 0d;
		for (DataKcswScedule dataKcswScedule : countByDj) {
			String djmc = dataKcswScedule.getDjmc();
			if("3271".equals(djmc) || "7109".equals(djmc)){
				yi = yi + Double.parseDouble(dataKcswScedule.getSumCksl());
			}else if ("3272".equals(djmc) || "7110".equals(djmc)) {
				er = er + Double.parseDouble(dataKcswScedule.getSumCksl());
			}else if ("3273".equals(djmc) || "7111".equals(djmc)) {
				san = san + Double.parseDouble(dataKcswScedule.getSumCksl());
			}
		}
		modelMap.put("yi", yi);
		modelMap.put("er", er);
		modelMap.put("san", san);

		return modelMap;
	}

	public String queryByBl(String effectiveCapacity, Map<String, Object> map)  throws Exception {
		String sumCksl = dataKcglKcswDefaultMapper.countByBl(map);
		if(sumCksl!=null && StringUtils.isNotBlank(effectiveCapacity) && !"0".equals(effectiveCapacity)){
			/* 库存数量  */
			BigDecimal sumCksls = new BigDecimal(sumCksl.toString());
			/* 库存容量  */
			BigDecimal effectiveCapacitys = new BigDecimal(effectiveCapacity.toString());
			BigDecimal ss = new BigDecimal(1000);
			/* 库存数量除以1000，由千克转换为吨 */
			BigDecimal sumCksls2 = sumCksls.divide(ss);
			/* 库存/库容  */
			BigDecimal divide = sumCksls2.divide(effectiveCapacitys, 4, RoundingMode.CEILING);
			/* 转换为百分比  */
			BigDecimal s = new BigDecimal(100);
			BigDecimal multiply = divide.multiply(s);
			float a = multiply.floatValue();
			String string = "";
			if (a > 100) {
				string = "100";
			} else {
				string = multiply.toString();
			}
			return string;
		}
		return "0";
	}

	@Override
	public List<DataKcglKcswDefault> findCondition(DataKcglKcswDefaultExample example) throws Exception {
		return dataKcglKcswDefaultMapper.selectByExample(example);
	}

	@Override
	public List<Map<String, Object>> findAgentCondition(Map<String, Object> map) throws Exception {
		return dataKcglKcswDefaultMapper.findCondition(map);
	}

	//获取仓房货位
	@Override
	public List<DataKcglKcswDefault> getHouseOrWareList(Map<String, Object> modelMap) throws Exception {
		// TODO Auto-generated method stub
		return dataKcglKcswDefaultMapper.getHouseOrWareList(modelMap);
	}

	@Override
	public List<Map<String, Object>> selectCountByPz() throws Exception {
		return dataKcglKcswDefaultMapper.countByPz();
	}

	@Override
	public List<Map<String, Object>> selectCountByXz() throws Exception {
		return dataKcglKcswDefaultMapper.countByXz();
	}

	@Override
	public List<Map<String, Object>> selectCountByYear() throws Exception {
		return dataKcglKcswDefaultMapper.countByYear();
	}

	@Override
	public List<Map<String, Object>> selectCountByCity() throws Exception {
		return dataKcglKcswDefaultMapper.countByCity();
	}

	@Override
	public List<DataKcglKcswDefault> getMassageBych(Map<String, Object> modelMap) throws Exception {
		return dataKcglKcswDefaultMapper.getMassageBych(modelMap);
	}

	@Override
	public List<DataKcglKcswDefault> queryLKNewData(Map<String, Object> map) throws Exception {
		List<DataKcglKcswDefault> selectByExample = dataKcglKcswDefaultMapper.queryLKNewData(map);
		return selectByExample;
	}

	@Override
	public void updateKc(String userInfo, String profitlossSheet) throws Exception {

		if (null == userInfo || null == profitlossSheet) {
			return;
		}
		JSONObject user = JSONObject.parseObject(userInfo);
		JSONObject sheet = JSONObject.parseObject(profitlossSheet);

		/* 删除对应仓房的库存实物数据 */
		DataKcglKcswDefaultExample example = new DataKcglKcswDefaultExample();
		Criteria criteria = example.createCriteria();
		criteria.andChEqualTo(Integer.parseInt(sheet.get("houseId").toString()));
		criteria.andHwhEqualTo(Integer.parseInt(sheet.get("warehouseId").toString()));
		DataKcglKcswDefault kcsw = dataKcglKcswDefaultMapper.selectByExample(example).get(0);
		dataKcglKcswDefaultMapper.deleteByPrimaryKey(kcsw.getDataid());

		/* 插入形成库存数据 */
		DataKcglXckcDefault dataKcglXckcDefault = new DataKcglXckcDefault();
		String uuid = UUID.randomUUID().toString().replace("-", "");
		dataKcglXckcDefault.setDataid(uuid);
		dataKcglXckcDefault.setUnitid(user.get("orgId").toString());
		dataKcglXckcDefault.setPeriodid(kcsw.getPeriodid());
		Byte roundid = 0;
		dataKcglXckcDefault.setRoundid(roundid);
		dataKcglXckcDefault.setModifydate(new Date());
		dataKcglXckcDefault.setBuilder(user.get("username").toString());
		dataKcglXckcDefault.setMxpz(sheet.get("grainKind").toString());
		dataKcglXckcDefault.setLkmc(user.get("orgName")==null?"":user.get("orgName").toString());
		dataKcglXckcDefault.setPz(sheet.get("grainKind").toString());
		dataKcglXckcDefault.setSjcf(Integer.parseInt(sheet.get("houseId").toString()));
		dataKcglXckcDefault.setDj(sheet.get("grainGrade").toString());
		dataKcglXckcDefault.setSjhw(Integer.parseInt(sheet.get("warehouseId").toString()));
		dataKcglXckcDefault.setScnf(sheet.get("productionYear").toString());
		dataKcglXckcDefault.setCazylx("溢出");
		double xzklhjz = Double.valueOf(sheet.get("incomeTonnage").toString());
		dataKcglXckcDefault.setXxklhjz(xzklhjz);
		dataKcglXckcDefault.setTzdh(0);
		dataKcglXckcDefault.setShoworder(0);
		dataKcglXckcDefault.setBizno("0");

		int count = dataKcglXckcDefaultMapper.insertSelective(dataKcglXckcDefault);

		if (count > 0) {
			/* 插入分仓保管账数据  */
			DataKcglFcbgzDefault dataKcglFcbgzDefault = new DataKcglFcbgzDefault();
			dataKcglFcbgzDefault.setDataid(uuid);
			dataKcglFcbgzDefault.setUnitid(user.get("orgId").toString());
			dataKcglFcbgzDefault.setRoundid(roundid);
			dataKcglFcbgzDefault.setPeriodid(kcsw.getPeriodid());
			dataKcglFcbgzDefault.setModifydate(new Date());
			dataKcglFcbgzDefault.setBuilder(dataKcglXckcDefault.getBuilder());
			dataKcglFcbgzDefault.setLkmc(dataKcglXckcDefault.getLkmc());
			dataKcglFcbgzDefault.setCh(kcsw.getCh());
			dataKcglFcbgzDefault.setHwh(kcsw.getHwh());
			dataKcglFcbgzDefault.setPz(dataKcglXckcDefault.getPz());
			dataKcglFcbgzDefault.setZcsl(xzklhjz);
			dataKcglFcbgzDefault.setKcsl(0d);
			dataKcglFcbgzDefault.setJzr(user.get("username").toString());
			dataKcglFcbgzDefault.setMxpz(dataKcglXckcDefault.getMxpz());
			dataKcglFcbgzDefault.setDj(dataKcglXckcDefault.getDj());
			dataKcglFcbgzDefault.setCjsj(new Date());
			dataKcglFcbgzDefault.setDirection(1);
			dataKcglFcbgzDefault.setScnf(dataKcglXckcDefault.getScnf());

			dataKcglFcbgzDefaultMapper.insertSelective(dataKcglFcbgzDefault);
		}
	}

	/**
	 * 根据orgId查询库存数量
	 */
	@Override
	public List<DataKcglKcswDefault> queryKcData(Integer orgId,Integer houseId,Integer warehouseId) throws Exception {
		// TODO Auto-generated method stub
		DataKcglKcswDefaultExample example = new DataKcglKcswDefaultExample();
        Criteria createCriteria = example.createCriteria();
        if(orgId!=null){
        	createCriteria.andUnitidEqualTo(String.valueOf(orgId));
        }
        if(houseId!=null){
        	createCriteria.andChEqualTo(houseId);
        }
        if(warehouseId!=null){
        	createCriteria.andHwhEqualTo(warehouseId);
        }
		return dataKcglKcswDefaultMapper.selectByExample(example);
	}

	@Override
	public String countByBl(Map<String, Object> map) throws Exception {
		String kczl = dataKcglKcswDefaultMapper.countByBl(map);
		return kczl;
	}

	@Override
	public Map<String, Object> getDateByChHwh(String orgId,String houseId,String wareHouseId) throws Exception {
		List<DataKcglKcswDefault> list = null;
		Map<String, Object> modelMap = new HashMap<String, Object>();
    	modelMap.put("orgId", orgId);
    	modelMap.put("houseId", houseId);
    	modelMap.put("wareHouseId", wareHouseId);
    	list = dataKcglKcswDefaultMapper.getDateByChHwh(modelMap);
    	Integer pz = 0;
    	Integer mxpz = 0;
    	Integer dj = 0;
    	Integer hwxz = 0;
    	Integer gb = 0;
    	String rq = "";
    	Integer scnf = null;
    	Double kcsl = 0.0;
    	if(list.size()>0 && list!=null){
    		 pz = Integer.parseInt(list.get(0).getPz());
    		 mxpz = Integer.parseInt(list.get(0).getMxpz());
    		 dj = Integer.parseInt(list.get(0).getDj());
    		 hwxz = Integer.parseInt(list.get(0).getHwxz());
    		 gb = Integer.parseInt(list.get(0).getGb());
    		 rq = ParameterUtil.datetime2string(list.get(0).getRq());
    		 scnf = list.get(0).getScnf();
    		 kcsl = list.get(0).getKcsl();
    	}
    	modelMap.put("pz", pz);
    	modelMap.put("mxpz", mxpz);
    	modelMap.put("dj", dj);
    	modelMap.put("hwxz", hwxz);
    	modelMap.put("gb", gb);
    	modelMap.put("rq", rq);
    	modelMap.put("scnf", scnf);
    	modelMap.put("kcsl", kcsl);
		return modelMap;
	}

	@Override
	public Map<String, Object> findNumManager(Map<String, Object> map) throws Exception {
		return dataKcglKcswDefaultMapper.findNumManager(map);
	}

	@Override
	public void updateKcswLsxz(DataKcglKcswDefault record, DataKcglKcswDefaultExample example) throws Exception {
		dataKcglKcswDefaultMapper.updateByExampleSelective(record, example);
	}

	@Override
	public List<DataKcglKcswDefault> findListOrRcsj(Map<String, Object> map) throws Exception {
		return dataKcglKcswDefaultMapper.findListOrRcsj(map);
	}

	@Override
	public Map<String, Object> countByBlType(Integer orgId) throws Exception {
		Map<String, Object> param_map = new HashMap<String, Object>();
		param_map.put("orgId", orgId);
		List<Map<String, Object>> list = dataKcglKcswDefaultMapper.countByBlType(param_map);

    	Map<String, Object> result_map = new HashMap<String, Object>();
    	result_map.put("lskczl", list.get(0).get("kczl"));
    	result_map.put("yzkczl", list.get(1).get("kczl"));
    	result_map.put("kczl", list.get(2).get("kczl"));

		return result_map;
	}

	@Override
	public PageInfo<DataKcglKcswDefault> queryYYSSL(Integer pageNum, Integer pageSize, String kcswStr, String order, Integer orgId)
			throws Exception {
		ObjectMapper mapper = new ObjectMapper();
    	DataKcglKcswDefault kcsw = null;
    	PageInfo<DataKcglKcswDefault> pageInfo = null;
    	//Map<String,Object> map = new HashMap<String,Object>();
    	DataKcglKcswDefaultExample example = new DataKcglKcswDefaultExample();
    	DataKcglKcswDefaultExample.Criteria criteria = example.createCriteria();

    	if (null != kcswStr && !"".equals(kcswStr)) {
			kcsw = mapper.readValue(kcswStr, DataKcglKcswDefault.class);
		} else {
			kcsw = new DataKcglKcswDefault();
		}
		/* 仓房 */
		if (null != kcsw.getCh() && !"".equals(kcsw.getCh())) {
			criteria.andChEqualTo(kcsw.getCh());
		}
		/* 货位 */
		if (null != kcsw.getHwh() && !"".equals(kcsw.getHwh())) {
			criteria.andHwhEqualTo(kcsw.getHwh());
		}
		/* 品种 */
		if (null != kcsw.getPz() && !"".equals(kcsw.getPz())) {
			criteria.andPzEqualTo(kcsw.getPz());
		}
		/* 单位 */
		if (null != orgId) {
			criteria.andUnitidEqualTo(orgId.toString());
		}
		/* 归档用最后一次编辑时间 */
		if (null != kcsw.getModifydate() && !"".equals(kcsw.getModifydate())) {
			criteria.andModifydateLessThan(kcsw.getModifydate());
		}

		if(null != pageNum && null != pageSize){
			PageHelper.startPage(pageNum, pageSize);
		}
		example.setOrderByClause(" to_number(ch) ");
		/* 1、查询库存实物表数据 */
		List<DataKcglKcswDefault> list = dataKcglKcswDefaultMapper.selectByExample(example);
		pageInfo = new PageInfo<DataKcglKcswDefault>(list);

		/* 2、查询对应仓房的生产年份，ZJ是自检要做判断 */
		if (!"ZJ".equals(order) && null != pageInfo.getList() && pageInfo.getList().size() > 0) {
			for (DataKcglKcswDefault kcswobj : pageInfo.getList()) {
				DataKcglFcbgzDefaultExample fcbgz_example = new DataKcglFcbgzDefaultExample();
				DataKcglFcbgzDefaultExample.Criteria fcbgz_criteria = fcbgz_example.createCriteria();
				fcbgz_criteria.andUnitidEqualTo(kcswobj.getUnitid());
				fcbgz_criteria.andChEqualTo(kcswobj.getCh());
				fcbgz_criteria.andHwhEqualTo(kcswobj.getHwh());
				fcbgz_criteria.andSrslGreaterThan(0d);//收入数量大于0
				fcbgz_criteria.andScnfIsNotNull();
				fcbgz_example.setOrderByClause(" rq DESC");
				List<DataKcglFcbgzDefault> fcbgz_list = fcbgzService.findByList(fcbgz_example);
				if (null != fcbgz_list && fcbgz_list.size() > 0) {
					int scnf = Integer.parseInt(ObjectUtils.toString(fcbgz_list.get(0).getScnf(), "0"));
					kcswobj.setScnf(scnf);
					//kcswobj.setCjsj(fcbgz_list.get(0).getCjsj());
				}
			}
		}

		return pageInfo;
	}

	@Override
	public List<DataKcglKcswDefault> importList(HttpServletRequest request, HttpServletResponse response, 
			String kcswStr, String order) throws Exception {
		List<DataKcglKcswDefault> list = null;
		
		String orgInfo = ObjectUtils.toString(request.getSession().getAttribute("orgInfo"),"");
		JSONObject org = null;
		String orgName = "";
		String orgId = "";
		if (null != orgInfo && !"".equals(orgInfo)) {
			org = JSONObject.parseObject(orgInfo);
			orgName = org.get("orgName") == null?"":org.get("orgName").toString();
			orgId = org.get("orgId") == null?"":org.get("orgId").toString();
			if (StringUtils.isNotBlank(orgId)) {
				
			}
		}

		HSSFWorkbook workbook = new HSSFWorkbook();
		//创建一个Excel表单,参数为sheet的名字
		HSSFSheet sheet = workbook.createSheet("库存数量统计");

		//创建表头
        setKcslTitle(workbook, sheet);
        
        PageInfo<DataKcglKcswDefault> pageInfo = queryYYSSL(null, null, kcswStr, order, StringUtils.isNotBlank(orgId)?Integer.parseInt(orgId) : null);
        list = pageInfo.getList();
        
        int rowNum = 1;
        DataKcglKcswDefault serviceVo = null;
        for (int i = 0; i < list.size(); i++) {
        	serviceVo = list.get(i);
            HSSFRow row = sheet.createRow(rowNum);
            row.createCell(0).setCellValue(i++);
            row.createCell(1).setCellValue(orgName);
            row.createCell(2).setCellValue(getStorehouse(serviceVo.getCh(), Integer.parseInt(serviceVo.getUnitid())));
            row.createCell(3).setCellValue(getWarehouse(serviceVo.getHwh()));
            row.createCell(4).setCellValue(getEnum(Integer.parseInt(serviceVo.getPz())));
            row.createCell(5).setCellValue(getEnum(Integer.parseInt(serviceVo.getHwxz())));
            row.createCell(6).setCellValue(serviceVo.getKcsl()/1000);
            row.createCell(7).setCellValue(serviceVo.getRksl()/1000);
            row.createCell(8).setCellValue(serviceVo.getWyssl()/1000);
            row.createCell(9).setCellValue(getEnum(serviceVo.getScnf()));
            rowNum++;
        }
        String fileName = "库存数量统计.xlsx";
        //清空response
        response.reset();
        //设置response的Header
        response.addHeader("Content-Disposition", "attachment;filename="+ fileName);
        OutputStream os = new BufferedOutputStream(response.getOutputStream());

        response.setContentType("application/vnd.ms-excel;charset=gb2312");
        //将excel写入到输出流中
        workbook.write(os);
        os.flush();
        os.close();
		
		return null;
	}

	@Override
	public Map<String, Object> queryFkcfData(String orgId, Integer ch) throws Exception {
		Map<String, Object> map = new HashMap<>();

		DataKcglKcswDefaultExample example = new DataKcglKcswDefaultExample();
		DataKcglKcswDefaultExample.Criteria criteria = example.createCriteria();
		criteria.andUnitidEqualTo(orgId);
		if (null != ch) {
			criteria.andChEqualTo(ch);
		}
		example.setOrderByClause(" to_number(ch) ");
		List<DataKcglKcswDefault> list = dataKcglKcswDefaultMapper.queryFkcfData(example);

		map.put("status", "success");
		map.put("msg", list);

		return map;
	}

	public void setKcslTitle(HSSFWorkbook workbook, HSSFSheet sheet) throws Exception {
		HSSFRow row = sheet.createRow(0);
        //设置数据所在列的宽度，setColumnWidth的第二个参数要乘以256，这个参数的单位是1/256个字符宽度
        sheet.setColumnWidth(0, 5*256);
        sheet.setColumnWidth(1, 10*256);
        sheet.setColumnWidth(2, 10*256);
        sheet.setColumnWidth(3, 10*256);
        sheet.setColumnWidth(4, 10*256);
        sheet.setColumnWidth(5, 10*256);
        sheet.setColumnWidth(6, 10*256);
        sheet.setColumnWidth(7, 10*256);
        sheet.setColumnWidth(8, 10*256);
        sheet.setColumnWidth(9, 10*256);

        HSSFCellStyle style = workbook.createCellStyle();
        HSSFFont font = workbook.createFont();
        font.setBoldweight(Font.BOLDWEIGHT_BOLD);
        style.setFont(font);

        HSSFCell cell = null;

        cell = row.createCell(0);
        cell.setCellValue("序号");
        cell.setCellStyle(style);
        
        cell = row.createCell(1);
        cell.setCellValue("储存库点");
        cell.setCellStyle(style);
        
        cell = row.createCell(2);
        cell.setCellValue("仓房名称");
        cell.setCellStyle(style);
        
        cell = row.createCell(3);
        cell.setCellValue("货位名称");
        cell.setCellStyle(style);
        
        cell = row.createCell(4);
        cell.setCellValue("粮油品种");
        cell.setCellStyle(style);
        
        cell = row.createCell(5);
        cell.setCellValue("粮油性质");
        cell.setCellStyle(style);
        
        cell = row.createCell(6);
        cell.setCellValue("库存数量（吨）");
        cell.setCellStyle(style);
        
        cell = row.createCell(7);
        cell.setCellValue("已验收数量（吨）");
        cell.setCellStyle(style);
        
        cell = row.createCell(8);
        cell.setCellValue("未验收数量（吨）");
        cell.setCellStyle(style);
        
        cell = row.createCell(9);
        cell.setCellValue("收获年度");
        cell.setCellStyle(style);
	}

	public String getEnum(Integer enumid) {
		String strResult = basicEnumFeignService.getEnumData(enumid);
		String enumname = "";
		if (null != strResult && !"".equals(strResult)) {
			JSONObject enum_obj = JSONObject.parseObject(strResult);
			enumname = enum_obj.get("enumname")+"";
		}
		return enumname;
	}

	public String getStorehouse(Integer id, Integer orgId) {
		String strResult = basicStorehouseFeignService.getStorehouse(id, orgId);
		String storehouseName = "";
		if (null != strResult && !"".equals(strResult)) {
			JSONObject enum_obj = JSONObject.parseObject(strResult);
			storehouseName = enum_obj.get("storehouseName")+"";
		}
		return storehouseName;
	}

	public String getWarehouse(Integer id) {
		String strResult = basicWarehouseFeignService.getWarehouse(id);
		String warehouseName = "";
		if (null != strResult && !"".equals(strResult)) {
			JSONObject enum_obj = JSONObject.parseObject(strResult);
			warehouseName = enum_obj.get("warehouseName")+"";
		}
		return warehouseName;
	}

	@Override
	public List<Integer> getHouseIdList(String list, Integer orgId) throws Exception {
		List<Integer> list1 = new ArrayList<Integer>();
        Map<String, Object> modelMap = new HashMap<>();
        modelMap.put("UnitID", orgId);
        if(list!=null){
        	list = "["+list+"]";
            List<Map<String,Object>> listQuality = new Gson().fromJson(list, new TypeToken<List<Map<String,Object>>>(){}.getType());  
            for (int i = 0; i < listQuality.size(); i++) {
                Map<String,Object> map = (Map<String,Object>)listQuality.get(i);
                //int houseId=listQuality.get(i).getHouseId();
                String id = ObjectUtils.toString(map.get("house_id"));
                if(id.indexOf(".") != -1) {
                    id = id.substring(0,id.indexOf("."));
                }
                int houseId=Integer.parseInt(id);
                if(!list1.contains(houseId)){
                    list1.add(houseId);
                }
            }
        }
        
        List<DataKcglKcswDefault> listKc = getHouseOrWareList(modelMap);
        for (int j = 0; j < listKc.size(); j++) {
              int houseId=listKc.get(j).getCh();
              list1.add(houseId);
        }
		return list1;
	}

	@Override
	public List<DataKcglKcswDefault> getHouseIdList(Integer days, String list, DataKcglKcswDefault kcsw, Integer orgId)
			throws Exception {
		if (days == null) {
        	days=0;
        }
        
        List<DataKcglKcswDefault> olist = new ArrayList<DataKcglKcswDefault>();
        if(null != list){
    	   list = "["+list+"]";
           List<Map<String,Object>> listQuality = new Gson().fromJson(list, new TypeToken<List<Map<String,Object>>>(){}.getType());  
           DataKcglKcswDefault dataKcglKcswDefault=new DataKcglKcswDefault();
           
           for (int i = 0; i < listQuality.size(); i++) {
               Map<String,Object> map = (Map<String,Object>)listQuality.get(i);
               
               String houseId = ObjectUtils.toString(map.get("house_id"));
               String warehouseId = ObjectUtils.toString(map.get("warehouse_id"));
               String subType=String.valueOf(map.get("sub_type_detailed"));
               String quality = ObjectUtils.toString(map.get("quality"));
               String level1=String.valueOf(map.get("level"));
               String level = ObjectUtils.toString(level1);
               String number = ObjectUtils.toString(map.get("number"));
               
               if(houseId.indexOf(".") != -1) {
               	houseId = houseId.substring(0,houseId.indexOf("."));
               }
               if(warehouseId.indexOf(".") != -1) {
               	warehouseId = houseId.substring(0,warehouseId.indexOf("."));
               }
               if(subType.indexOf(".") != -1) {
               	subType = subType.substring(0,subType.indexOf("."));
               }
               if(level.indexOf(".") != -1) {
               	level = level.substring(0,level.indexOf("."));
               }
               dataKcglKcswDefault.setCh(Integer.parseInt(houseId));
               dataKcglKcswDefault.setHwh(Integer.parseInt(warehouseId));
               dataKcglKcswDefault.setHwxz(quality);
             
               dataKcglKcswDefault.setPz(String.valueOf(subType));
               dataKcglKcswDefault.setDj(level);
               dataKcglKcswDefault.setKcsl(Double.parseDouble(number));
               olist.add(dataKcglKcswDefault);
           }
		}
		 
       
        

		DataKcglKcswDefaultExample example = new DataKcglKcswDefaultExample();
		Criteria criteria = example.createCriteria();
		criteria.andUnitidEqualTo(orgId.toString());
			
		//获取当前时间，转化格式
		Date date = new Date();  
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");  
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.DAY_OF_YEAR, days);//正数可以得到当前时间+n天，负数可以得到当前时间-n天
        
        date = calendar.getTime();
        calendar.setTime(date);
		

        if(ParameterUtil.isnotnull(date)){
        	calendar.add(Calendar.YEAR, -2); // 年份减2
        	date = calendar.getTime();
            calendar.setTime(date);
            String time = sdf.format(date);
        	Date endDate = ParameterUtil.string2datetime(time);
        	criteria.andPzEqualTo("3164");
        	criteria.andRqLessThanOrEqualTo(endDate);
        }
        
        List<DataKcglKcswDefault> list2 = findCondition(example);
        
        DataKcglKcswDefaultExample example1 = new DataKcglKcswDefaultExample();
		Criteria criteria1= example1.createCriteria();
		criteria1.andUnitidEqualTo(orgId.toString());
		
        //其他的轮换时间三年
        if(ParameterUtil.isnotnull(date)){
        	calendar.add(Calendar.YEAR, -1); // 年份减3(calendar获取上面的时间已经减去2年,此时减少一年 即可)
        	date = calendar.getTime();
            calendar.setTime(date);
            String time = sdf.format(date);
        	Date endDate = ParameterUtil.string2datetime(time);
        	criteria1.andPzNotEqualTo("3164");
        	criteria1.andRqLessThanOrEqualTo(endDate);
        	
        }
        List<DataKcglKcswDefault> list3 = findCondition(example1);

        if(list3!=null && list3.size()>0){
        	for (DataKcglKcswDefault dataKcglKcswDefault3 : list3) {
        		olist.add(dataKcglKcswDefault3);
        	}
        }
        if(list2!=null && list2.size()>0){
        	for (DataKcglKcswDefault dataKcglKcswDefault2 : list2) {
        		olist.add(dataKcglKcswDefault2);
        	}
        }
		return olist;
	}
}
