package com.chinaitop.agile.service.impl;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.util.CellRangeAddress;
import org.springframework.stereotype.Service;

import com.chinaitop.agile.mapper.DataKcglKcswDefaultMapper;
import com.chinaitop.agile.service.RegistrationService;
import com.chinaitop.agile.utils.ParameterUtil;

@Service
public class RegistrationServiceImpl implements RegistrationService{

	@Resource
	private DataKcglKcswDefaultMapper dataKcglKcswDefaultMapper;

	@Override
	public List<Map<String, Object>> getWheatListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getWheatList(map);
	}

	@Override
	public List<Map<String, Object>> getCornListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getCornList(map);
	}

	@Override
	public List<Map<String, Object>> getSoybeanListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getSoybeanList(map);
	}

	@Override
	public List<Map<String, Object>> getRiceListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getRiceList(map);
	}
	
	@Override
	public List<Map<String, Object>> getCrudeOilListPageInfo(Map<String, Object> map) {
		return dataKcglKcswDefaultMapper.getCrudeOilList(map);
	}

	/**
	 * 这个是导出全部的
	 */
	@Override
	public HSSFWorkbook wheatdataTransfor(List<Map<String, Object>> list, String zbr, String shdw, String dwfzr, String banben, String sfdcqb) {
		HSSFWorkbook wb = new HSSFWorkbook();
		String name = "小麦";
		if ("0".equals(sfdcqb)) {//导出全部列
			HSSFSheet sheet = wb.createSheet(name);
			// 表格合并单元格的样式：参数分别为[起始行、结束行、起始列、结束列],0代表第一行或者第一列
			//不需要合并的格子不需要专门设置单元格的样式
			CellRangeAddress rangeAddress = new CellRangeAddress(0,0,0,28);//第一行:天津市粮食储备有限公司市级储备小麦轮换入库情况登统表
			CellRangeAddress rangeAddress1 = new CellRangeAddress(1,1,0,6);//收货单位
			CellRangeAddress rangeAddress2 = new CellRangeAddress(1,1,7,24);//填报日期
			CellRangeAddress rangeAddress3 = new CellRangeAddress(1,1,25,28);//计量单位
			CellRangeAddress rangeAddress4 = new CellRangeAddress(2,5,0,0);//序号
			CellRangeAddress rangeAddress5 = new CellRangeAddress(2,5,1,1);//车号
			CellRangeAddress rangeAddress6 = new CellRangeAddress(2,5,2,2);//仓号
			CellRangeAddress rangeAddress7 = new CellRangeAddress(2,5,3,3);//货位号
			CellRangeAddress rangeAddress8 = new CellRangeAddress(2,5,4,4);//品名
			CellRangeAddress rangeAddress9 = new CellRangeAddress(2,5,5,5);//生产年度
			CellRangeAddress rangeAddress10 = new CellRangeAddress(2,5,6,6);//入库日期
			CellRangeAddress rangeAddress11 = new CellRangeAddress(2,5,7,7);//入库数量
			CellRangeAddress rangeAddress12 = new CellRangeAddress(2,5,8,8);//等级
			CellRangeAddress rangeAddress13 = new CellRangeAddress(2,2,9,26);//入库质量指标
			CellRangeAddress rangeAddress14 = new CellRangeAddress(2,5,27,27);//存储方式
			CellRangeAddress rangeAddress15 = new CellRangeAddress(2,5,28,28);//备注
			CellRangeAddress rangeAddress16 = new CellRangeAddress(3,3,11,15);//杂质
			CellRangeAddress rangeAddress17 = new CellRangeAddress(3,3,16,24);//不完善粒
			CellRangeAddress rangeAddress18 = new CellRangeAddress(3,5,9,9);//水分
			CellRangeAddress rangeAddress19 = new CellRangeAddress(3,5,10,10);//容重
			CellRangeAddress rangeAddress20 = new CellRangeAddress(3,5,25,25);//色泽气味
			CellRangeAddress rangeAddress21 = new CellRangeAddress(3,5,26,26);//硬度指数
			CellRangeAddress rangeAddress22 = new CellRangeAddress(4,4,18,20);//病斑粒
			CellRangeAddress rangeAddress23 = new CellRangeAddress(4,5,11,11);//杂质总量
			CellRangeAddress rangeAddress24 = new CellRangeAddress(4,5,12,12);//矿物质
			CellRangeAddress rangeAddress25 = new CellRangeAddress(4,5,13,13);//无机杂质
			CellRangeAddress rangeAddress26 = new CellRangeAddress(4,5,14,14);//有机杂质
			CellRangeAddress rangeAddress27 = new CellRangeAddress(4,5,15,15);//筛下物%
			CellRangeAddress rangeAddress28 = new CellRangeAddress(4,5,16,16);//不完善粒总量
			CellRangeAddress rangeAddress29 = new CellRangeAddress(4,5,17,17);//虫蚀粒
			CellRangeAddress rangeAddress30 = new CellRangeAddress(4,5,21,21);//热损伤粒%
			CellRangeAddress rangeAddress31 = new CellRangeAddress(4,5,22,22);//破损粒
			CellRangeAddress rangeAddress32 = new CellRangeAddress(4,5,23,23);//生芽粒
			CellRangeAddress rangeAddress33 = new CellRangeAddress(4,5,24,24);//生霉粒
			CellRangeAddress rangeAddress34 = new CellRangeAddress(5,5,18,18);//病斑粒总量
			CellRangeAddress rangeAddress35 = new CellRangeAddress(5,5,19,19);//黑胚粒
			CellRangeAddress rangeAddress36 = new CellRangeAddress(5,5,20,20);//赤霉病粒

			sheet.addMergedRegion(rangeAddress);
			sheet.addMergedRegion(rangeAddress1);
			sheet.addMergedRegion(rangeAddress2);
			sheet.addMergedRegion(rangeAddress3);
			sheet.addMergedRegion(rangeAddress4);
			sheet.addMergedRegion(rangeAddress5);
			sheet.addMergedRegion(rangeAddress6);
			sheet.addMergedRegion(rangeAddress7);
			sheet.addMergedRegion(rangeAddress8);
			sheet.addMergedRegion(rangeAddress9);
			sheet.addMergedRegion(rangeAddress10);
			sheet.addMergedRegion(rangeAddress11);
			sheet.addMergedRegion(rangeAddress12);
			sheet.addMergedRegion(rangeAddress13);
			sheet.addMergedRegion(rangeAddress14);
			sheet.addMergedRegion(rangeAddress15);
			sheet.addMergedRegion(rangeAddress16);
			sheet.addMergedRegion(rangeAddress17);
			sheet.addMergedRegion(rangeAddress18);
			sheet.addMergedRegion(rangeAddress19);
			sheet.addMergedRegion(rangeAddress20);
			sheet.addMergedRegion(rangeAddress21);
			sheet.addMergedRegion(rangeAddress22);
			sheet.addMergedRegion(rangeAddress23);
			sheet.addMergedRegion(rangeAddress24);
			sheet.addMergedRegion(rangeAddress25);
			sheet.addMergedRegion(rangeAddress26);
			sheet.addMergedRegion(rangeAddress27);
			sheet.addMergedRegion(rangeAddress28);
			sheet.addMergedRegion(rangeAddress29);
			sheet.addMergedRegion(rangeAddress30);
			sheet.addMergedRegion(rangeAddress31);
			sheet.addMergedRegion(rangeAddress32);
			sheet.addMergedRegion(rangeAddress33);
			sheet.addMergedRegion(rangeAddress34);
			sheet.addMergedRegion(rangeAddress35);
			sheet.addMergedRegion(rangeAddress36);

			HSSFCellStyle headStyle = wb.createCellStyle();
			HSSFFont headFont = wb.createFont();
			headFont.setFontName("黑体");
			headFont.setFontHeightInPoints((short) 18);
			headFont.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
			headStyle.setFont(headFont);
			headStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
			headStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

			HSSFCellStyle titleStyle = wb.createCellStyle();
			HSSFFont titleFont = wb.createFont();
			titleFont.setFontName("黑体");
			titleFont.setFontHeightInPoints((short) 12);
			titleStyle.setFont(titleFont);

			HSSFCellStyle contentStyle = wb.createCellStyle();
			HSSFFont contentFont = wb.createFont();
			contentFont.setFontName("黑体");
			contentFont.setFontHeightInPoints((short) 12);
			contentStyle.setFont(contentFont);
			contentStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
			contentStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
			contentStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
			contentStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);
			contentStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
			contentStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

			//第一行
			HSSFRow sheetRow = sheet.createRow(0);
			HSSFCell cell = sheetRow.createCell(0);
			cell.setCellValue("天津市粮食储备有限公司市级储备小麦轮换入库情况登统表");
			cell.setCellStyle(headStyle);

			//第二行
			HSSFRow sheetRow1 = sheet.createRow(1);
			HSSFCell cell1 = sheetRow1.createCell(0);
			HSSFCell cell2 = sheetRow1.createCell(7);
			HSSFCell cell3 = sheetRow1.createCell(25);
			cell1.setCellValue("收货单位："+ (shdw==null?"":shdw));
			cell1.setCellStyle(titleStyle);
			SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日");
			cell2.setCellValue("填报日期："+format.format(new Date()));
			cell2.setCellStyle(titleStyle);
			cell3.setCellValue("计量单位：吨（保留小数）");
			cell3.setCellStyle(titleStyle);

			//在表格的第一行设置与数据库列名对应的列的名称
			int rowNum = 2;//第三行
			HSSFRow row = sheet.createRow(rowNum);
			HSSFCell rowCell1 =  row.createCell(0);	
			HSSFCell rowCell2 =  row.createCell(1);	
			HSSFCell rowCell3 =  row.createCell(2);	
			HSSFCell rowCell4 =  row.createCell(3);	
			HSSFCell rowCell5 =  row.createCell(4);	
			HSSFCell rowCell6 =  row.createCell(5);	
			HSSFCell rowCell7 =  row.createCell(6);	
			HSSFCell rowCell8 =  row.createCell(7);	
			HSSFCell rowCell9 =  row.createCell(8);	
			HSSFCell rowCell10 = row.createCell(9);	
			HSSFCell rowCell11 = row.createCell(10);
			HSSFCell rowCell12 = row.createCell(11);
			HSSFCell rowCell13 = row.createCell(12);
			HSSFCell rowCell14 = row.createCell(13);
			HSSFCell rowCell15 = row.createCell(14);
			HSSFCell rowCell16 = row.createCell(15);
			HSSFCell rowCell17 = row.createCell(16);
			HSSFCell rowCell18 = row.createCell(17);
			HSSFCell rowCell19 = row.createCell(18);
			HSSFCell rowCell20 = row.createCell(19);
			HSSFCell rowCell21 = row.createCell(20);
			HSSFCell rowCell22 = row.createCell(21);
			HSSFCell rowCell23 = row.createCell(22);
			HSSFCell rowCell24 = row.createCell(23);
			HSSFCell rowCell25 = row.createCell(24);
			HSSFCell rowCell26 = row.createCell(25);
			HSSFCell rowCell27 = row.createCell(26);
			HSSFCell rowCell28 = row.createCell(27);
			HSSFCell rowCell29 = row.createCell(28);

			rowCell1.setCellValue("序号");
			rowCell2.setCellValue("车号");
			rowCell3.setCellValue("仓房名称");
			rowCell4.setCellValue("货位名称");
			rowCell5.setCellValue("品名");
			rowCell6.setCellValue("生产年度");
			rowCell7.setCellValue("入库日期");
			rowCell8.setCellValue("入库数量");
			rowCell9.setCellValue("等级");
			rowCell10.setCellValue("入库质量指标");
			rowCell28.setCellValue("存储方式");
			rowCell29.setCellValue("备注");
			rowCell1.setCellStyle(contentStyle);
			rowCell2.setCellStyle(contentStyle);
			rowCell3.setCellStyle(contentStyle);
			rowCell4.setCellStyle(contentStyle);
			rowCell5.setCellStyle(contentStyle);
			rowCell6.setCellStyle(contentStyle);
			rowCell7.setCellStyle(contentStyle);
			rowCell8.setCellStyle(contentStyle);
			rowCell9.setCellStyle(contentStyle);
			rowCell10.setCellStyle(contentStyle);
			rowCell11.setCellStyle(contentStyle);
			rowCell12.setCellStyle(contentStyle);
			rowCell13.setCellStyle(contentStyle);
			rowCell14.setCellStyle(contentStyle);
			rowCell15.setCellStyle(contentStyle);
			rowCell16.setCellStyle(contentStyle);
			rowCell17.setCellStyle(contentStyle);
			rowCell18.setCellStyle(contentStyle);
			rowCell19.setCellStyle(contentStyle);
			rowCell20.setCellStyle(contentStyle);
			rowCell21.setCellStyle(contentStyle);
			rowCell22.setCellStyle(contentStyle);
			rowCell23.setCellStyle(contentStyle);
			rowCell24.setCellStyle(contentStyle);
			rowCell25.setCellStyle(contentStyle);
			rowCell26.setCellStyle(contentStyle);
			rowCell27.setCellStyle(contentStyle);
			rowCell28.setCellStyle(contentStyle);
			rowCell29.setCellStyle(contentStyle);

			rowNum+=1;//第四行
			//杂质//不完善粒//水分//容重//色泽气味//硬度指数
			HSSFRow row1 = sheet.createRow(rowNum);
			HSSFCell row1Cell1 = row1.createCell(0);
			HSSFCell row1Cell2 = row1.createCell(1);
			HSSFCell row1Cell3 = row1.createCell(2);
			HSSFCell row1Cell4 = row1.createCell(3);
			HSSFCell row1Cell5 = row1.createCell(4);
			HSSFCell row1Cell6 = row1.createCell(5);
			HSSFCell row1Cell7 = row1.createCell(6);
			HSSFCell row1Cell8 = row1.createCell(7);
			HSSFCell row1Cell9 = row1.createCell(8);
			HSSFCell row1Cell10 = row1.createCell(9);
			HSSFCell row1Cell11 = row1.createCell(10);
			HSSFCell row1Cell12 = row1.createCell(11);
			HSSFCell row1Cell13 = row1.createCell(12);
			HSSFCell row1Cell14 = row1.createCell(13);
			HSSFCell row1Cell15 = row1.createCell(14);
			HSSFCell row1Cell16 = row1.createCell(15);
			HSSFCell row1Cell17 = row1.createCell(16);
			HSSFCell row1Cell18 = row1.createCell(17);
			HSSFCell row1Cell19 = row1.createCell(18);
			HSSFCell row1Cell20 = row1.createCell(19);
			HSSFCell row1Cell21 = row1.createCell(20);
			HSSFCell row1Cell22 = row1.createCell(21);
			HSSFCell row1Cell23 = row1.createCell(22);
			HSSFCell row1Cell24 = row1.createCell(23);
			HSSFCell row1Cell25 = row1.createCell(24);
			HSSFCell row1Cell26 = row1.createCell(25);
			HSSFCell row1Cell27 = row1.createCell(26);
			HSSFCell row1Cell28 = row1.createCell(27);
			HSSFCell row1Cell29 = row1.createCell(28);
			row1Cell10.setCellValue("水分");
			row1Cell11.setCellValue("容重");
			row1Cell12.setCellValue("杂质");
			row1Cell17.setCellValue("不完善粒");
			row1Cell26.setCellValue("色泽气味");
			row1Cell27.setCellValue("硬度指数");
			row1Cell1.setCellStyle(contentStyle);
			row1Cell2.setCellStyle(contentStyle);
			row1Cell3.setCellStyle(contentStyle);
			row1Cell4.setCellStyle(contentStyle);
			row1Cell5.setCellStyle(contentStyle);
			row1Cell6.setCellStyle(contentStyle);
			row1Cell7.setCellStyle(contentStyle);
			row1Cell8.setCellStyle(contentStyle);
			row1Cell9.setCellStyle(contentStyle);
			row1Cell10.setCellStyle(contentStyle);
			row1Cell11.setCellStyle(contentStyle);
			row1Cell12.setCellStyle(contentStyle);
			row1Cell13.setCellStyle(contentStyle);
			row1Cell14.setCellStyle(contentStyle);
			row1Cell15.setCellStyle(contentStyle);
			row1Cell16.setCellStyle(contentStyle);
			row1Cell17.setCellStyle(contentStyle);
			row1Cell18.setCellStyle(contentStyle);
			row1Cell19.setCellStyle(contentStyle);
			row1Cell20.setCellStyle(contentStyle);
			row1Cell21.setCellStyle(contentStyle);
			row1Cell22.setCellStyle(contentStyle);
			row1Cell23.setCellStyle(contentStyle);
			row1Cell24.setCellStyle(contentStyle);
			row1Cell25.setCellStyle(contentStyle);
			row1Cell26.setCellStyle(contentStyle);
			row1Cell27.setCellStyle(contentStyle);
			row1Cell28.setCellStyle(contentStyle);
			row1Cell29.setCellStyle(contentStyle);

			rowNum+=1;//第五行
			//病斑粒//杂质总量//矿物质//无机杂质//有机杂质//筛下物%//不完善粒总量//虫蚀粒//热损伤粒%//破损粒//生芽粒//生霉粒
			HSSFRow row2 = sheet.createRow(rowNum);
			HSSFCell row2Cell1 = row2.createCell(0);
			HSSFCell row2Cell2 = row2.createCell(1);
			HSSFCell row2Cell3 = row2.createCell(2);
			HSSFCell row2Cell4 = row2.createCell(3);
			HSSFCell row2Cell5 = row2.createCell(4);
			HSSFCell row2Cell6 = row2.createCell(5);
			HSSFCell row2Cell7 = row2.createCell(6);
			HSSFCell row2Cell8 = row2.createCell(7);
			HSSFCell row2Cell9 = row2.createCell(8);
			HSSFCell row2Cell10 = row2.createCell(9);
			HSSFCell row2Cell11 = row2.createCell(10);
			HSSFCell row2Cell12 = row2.createCell(11);
			HSSFCell row2Cell13 = row2.createCell(12);
			HSSFCell row2Cell14 = row2.createCell(13);
			HSSFCell row2Cell15 = row2.createCell(14);
			HSSFCell row2Cell16 = row2.createCell(15);
			HSSFCell row2Cell17 = row2.createCell(16);
			HSSFCell row2Cell18 = row2.createCell(17);
			HSSFCell row2Cell19 = row2.createCell(18);
			HSSFCell row2Cell20 = row2.createCell(19);
			HSSFCell row2Cell21 = row2.createCell(20);
			HSSFCell row2Cell22 = row2.createCell(21);
			HSSFCell row2Cell23 = row2.createCell(22);
			HSSFCell row2Cell24 = row2.createCell(23);
			HSSFCell row2Cell25 = row2.createCell(24);
			HSSFCell row2Cell26 = row2.createCell(25);
			HSSFCell row2Cell27 = row2.createCell(26);
			HSSFCell row2Cell28 = row2.createCell(27);
			HSSFCell row2Cell29 = row2.createCell(28);
			row2Cell12.setCellValue("总量");//杂质总量
			row2Cell13.setCellValue("矿物质");
			row2Cell14.setCellValue("无机杂质");
			row2Cell15.setCellValue("有机杂质");
			row2Cell16.setCellValue("筛下物%");
			row2Cell17.setCellValue("总量");//不完善粒总量
			row2Cell18.setCellValue("虫蚀粒");
			row2Cell19.setCellValue("病斑粒");
			row2Cell22.setCellValue("热损伤粒%");
			row2Cell23.setCellValue("破损粒");
			row2Cell24.setCellValue("生芽粒");
			row2Cell25.setCellValue("生霉粒");
			row2Cell1.setCellStyle(contentStyle);
			row2Cell2.setCellStyle(contentStyle);
			row2Cell3.setCellStyle(contentStyle);
			row2Cell4.setCellStyle(contentStyle);
			row2Cell5.setCellStyle(contentStyle);
			row2Cell6.setCellStyle(contentStyle);
			row2Cell7.setCellStyle(contentStyle);
			row2Cell8.setCellStyle(contentStyle);
			row2Cell9.setCellStyle(contentStyle);
			row2Cell10.setCellStyle(contentStyle);
			row2Cell11.setCellStyle(contentStyle);
			row2Cell12.setCellStyle(contentStyle);
			row2Cell13.setCellStyle(contentStyle);
			row2Cell14.setCellStyle(contentStyle);
			row2Cell15.setCellStyle(contentStyle);
			row2Cell16.setCellStyle(contentStyle);
			row2Cell17.setCellStyle(contentStyle);
			row2Cell18.setCellStyle(contentStyle);
			row2Cell19.setCellStyle(contentStyle);
			row2Cell20.setCellStyle(contentStyle);
			row2Cell21.setCellStyle(contentStyle);
			row2Cell22.setCellStyle(contentStyle);
			row2Cell23.setCellStyle(contentStyle);
			row2Cell24.setCellStyle(contentStyle);
			row2Cell25.setCellStyle(contentStyle);
			row2Cell26.setCellStyle(contentStyle);
			row2Cell27.setCellStyle(contentStyle);
			row2Cell28.setCellStyle(contentStyle);
			row2Cell29.setCellStyle(contentStyle);

			rowNum+=1;//第六行
			//病斑粒总量//黑胚粒//赤霉病粒
			HSSFRow row3 = sheet.createRow(rowNum);
			HSSFCell row3Cell1 = row3.createCell(0);
			HSSFCell row3Cell2 = row3.createCell(1);
			HSSFCell row3Cell3 = row3.createCell(2);
			HSSFCell row3Cell4 = row3.createCell(3);
			HSSFCell row3Cell5 = row3.createCell(4);
			HSSFCell row3Cell6 = row3.createCell(5);
			HSSFCell row3Cell7 = row3.createCell(6);
			HSSFCell row3Cell8 = row3.createCell(7);
			HSSFCell row3Cell9 = row3.createCell(8);
			HSSFCell row3Cell10	= row3.createCell(9);
			HSSFCell row3Cell11	= row3.createCell(10);
			HSSFCell row3Cell12	= row3.createCell(11);
			HSSFCell row3Cell13	= row3.createCell(12);
			HSSFCell row3Cell14	= row3.createCell(13);
			HSSFCell row3Cell15	= row3.createCell(14);
			HSSFCell row3Cell16	= row3.createCell(15);
			HSSFCell row3Cell17	= row3.createCell(16);
			HSSFCell row3Cell18	= row3.createCell(17);
			HSSFCell row3Cell19 = row3.createCell(18);
			HSSFCell row3Cell20 = row3.createCell(19);
			HSSFCell row3Cell21 = row3.createCell(20);
			HSSFCell row3Cell22	= row3.createCell(21);
			HSSFCell row3Cell23	= row3.createCell(22);
			HSSFCell row3Cell24	= row3.createCell(23);
			HSSFCell row3Cell25	= row3.createCell(24);
			HSSFCell row3Cell26	= row3.createCell(25);
			HSSFCell row3Cell27	= row3.createCell(26);
			HSSFCell row3Cell28	= row3.createCell(27);
			HSSFCell row3Cell29	= row3.createCell(28);
			row3Cell19.setCellValue("总量");//病斑粒总量
			row3Cell20.setCellValue("黑胚粒");
			row3Cell21.setCellValue("赤霉病粒");
			row3Cell1.setCellStyle(contentStyle);
			row3Cell2.setCellStyle(contentStyle);
			row3Cell3.setCellStyle(contentStyle);
			row3Cell4.setCellStyle(contentStyle);
			row3Cell5.setCellStyle(contentStyle);
			row3Cell6.setCellStyle(contentStyle);
			row3Cell7.setCellStyle(contentStyle);
			row3Cell8.setCellStyle(contentStyle);
			row3Cell9.setCellStyle(contentStyle);
			row3Cell10.setCellStyle(contentStyle);
			row3Cell11.setCellStyle(contentStyle);
			row3Cell12.setCellStyle(contentStyle);
			row3Cell13.setCellStyle(contentStyle);
			row3Cell14.setCellStyle(contentStyle);
			row3Cell15.setCellStyle(contentStyle);
			row3Cell16.setCellStyle(contentStyle);
			row3Cell17.setCellStyle(contentStyle);
			row3Cell18.setCellStyle(contentStyle);
			row3Cell19.setCellStyle(contentStyle);
			row3Cell20.setCellStyle(contentStyle);
			row3Cell21.setCellStyle(contentStyle);
			row3Cell22.setCellStyle(contentStyle);
			row3Cell23.setCellStyle(contentStyle);
			row3Cell24.setCellStyle(contentStyle);
			row3Cell25.setCellStyle(contentStyle);
			row3Cell26.setCellStyle(contentStyle);
			row3Cell27.setCellStyle(contentStyle);
			row3Cell28.setCellStyle(contentStyle);
			row3Cell29.setCellStyle(contentStyle);

			Integer xh=1;
			double rksl = 0d;
			for(int i=0; i<list.size();i++){
				HSSFRow hssfRow = sheet.createRow(++rowNum);
				HSSFCell hssfCell1 = hssfRow.createCell(0);
				HSSFCell hssfCell2 = hssfRow.createCell(1);
				HSSFCell hssfCell3 = hssfRow.createCell(2);
				HSSFCell hssfCell4 = hssfRow.createCell(3);
				HSSFCell hssfCell5 = hssfRow.createCell(4);
				HSSFCell hssfCell6 = hssfRow.createCell(5);
				HSSFCell hssfCell7 = hssfRow.createCell(6);
				HSSFCell hssfCell8 = hssfRow.createCell(7);
				HSSFCell hssfCell9 = hssfRow.createCell(8);
				HSSFCell hssfCell10 = hssfRow.createCell(9);
				HSSFCell hssfCell11 = hssfRow.createCell(10);
				HSSFCell hssfCell12 = hssfRow.createCell(11);
				HSSFCell hssfCell13 = hssfRow.createCell(12);
				HSSFCell hssfCell14 = hssfRow.createCell(13);
				HSSFCell hssfCell15 = hssfRow.createCell(14);
				HSSFCell hssfCell16 = hssfRow.createCell(15);
				HSSFCell hssfCell17 = hssfRow.createCell(16);
				HSSFCell hssfCell18 = hssfRow.createCell(17);
				HSSFCell hssfCell19 = hssfRow.createCell(18);
				HSSFCell hssfCell20 = hssfRow.createCell(19);
				HSSFCell hssfCell21 = hssfRow.createCell(20);
				HSSFCell hssfCell22 = hssfRow.createCell(21);
				HSSFCell hssfCell23 = hssfRow.createCell(22);
				HSSFCell hssfCell24 = hssfRow.createCell(23);
				HSSFCell hssfCell25 = hssfRow.createCell(24);
				HSSFCell hssfCell26 = hssfRow.createCell(25);
				HSSFCell hssfCell27 = hssfRow.createCell(26);
				HSSFCell hssfCell28 = hssfRow.createCell(27);
				HSSFCell hssfCell29 = hssfRow.createCell(28);
				hssfCell1.setCellValue(xh);
				hssfCell2.setCellValue((String)list.get(i).get("cphm"));
				hssfCell3.setCellValue((String)list.get(i).get("cf"));
				hssfCell4.setCellValue((String)list.get(i).get("hw"));
				hssfCell5.setCellValue((String)list.get(i).get("lspz"));
				hssfCell6.setCellValue((String)list.get(i).get("scnf"));
				Date date = (Date)list.get(i).get("rq");
				hssfCell7.setCellValue(format.format(date));
				rksl = Double.parseDouble(list.get(i).get("rksl").toString());
				rksl = rksl/1000;
				String rksls = rksl+"";
				rksls = ParameterUtil.decimalFormat(3, rksls, true);
				hssfCell8.setCellValue(rksls);
				hssfCell9.setCellValue((String)list.get(i).get("lsdj"));
				hssfCell10.setCellValue((String)list.get(i).get("sf"));
				hssfCell11.setCellValue((String)list.get(i).get("rz"));
				hssfCell12.setCellValue((String)list.get(i).get("zzzl"));
				hssfCell13.setCellValue((String)list.get(i).get("kwz"));
				hssfCell14.setCellValue((String)list.get(i).get("wjzz"));
				hssfCell15.setCellValue((String)list.get(i).get("yjzz"));
				hssfCell16.setCellValue((String)list.get(i).get("sxw"));
				hssfCell17.setCellValue((String)list.get(i).get("bwslzl"));
				hssfCell18.setCellValue((String)list.get(i).get("csl"));
				hssfCell19.setCellValue((String)list.get(i).get("bblzl"));
				hssfCell20.setCellValue((String)list.get(i).get("hpl"));
				hssfCell21.setCellValue((String)list.get(i).get("cmbl"));
				hssfCell22.setCellValue((String)list.get(i).get("rssl"));
				hssfCell23.setCellValue((String)list.get(i).get("psl"));
				hssfCell24.setCellValue((String)list.get(i).get("syl"));
				hssfCell25.setCellValue((String)list.get(i).get("sml"));
				hssfCell26.setCellValue((String)list.get(i).get("szqw"));
				hssfCell27.setCellValue((String)list.get(i).get("ydzs"));
				hssfCell28.setCellValue((String)list.get(i).get("ccfs"));
				hssfCell29.setCellValue((String)list.get(i).get(""));//备注
				hssfCell1.setCellStyle(contentStyle);
				hssfCell2.setCellStyle(contentStyle);
				hssfCell3.setCellStyle(contentStyle);
				hssfCell4.setCellStyle(contentStyle);
				hssfCell5.setCellStyle(contentStyle);
				hssfCell6.setCellStyle(contentStyle);
				hssfCell7.setCellStyle(contentStyle);
				hssfCell8.setCellStyle(contentStyle);
				hssfCell9.setCellStyle(contentStyle);
				hssfCell10.setCellStyle(contentStyle);
				hssfCell11.setCellStyle(contentStyle);
				hssfCell12.setCellStyle(contentStyle);
				hssfCell13.setCellStyle(contentStyle);
				hssfCell14.setCellStyle(contentStyle);
				hssfCell15.setCellStyle(contentStyle);
				hssfCell16.setCellStyle(contentStyle);
				hssfCell17.setCellStyle(contentStyle);
				hssfCell18.setCellStyle(contentStyle);
				hssfCell19.setCellStyle(contentStyle);
				hssfCell20.setCellStyle(contentStyle);
				hssfCell21.setCellStyle(contentStyle);
				hssfCell22.setCellStyle(contentStyle);
				hssfCell23.setCellStyle(contentStyle);
				hssfCell24.setCellStyle(contentStyle);
				hssfCell25.setCellStyle(contentStyle);
				hssfCell26.setCellStyle(contentStyle);
				hssfCell27.setCellStyle(contentStyle);
				hssfCell28.setCellStyle(contentStyle);
				hssfCell29.setCellStyle(contentStyle);
				++xh;
			}
			HSSFRow hssfRow = sheet.createRow(rowNum+1);
			hssfRow.createCell(0).setCellValue("单位负责人：" + (dwfzr==null?"":dwfzr));
			hssfRow.createCell(6).setCellValue("科长：");
			hssfRow.createCell(13).setCellValue("制表人："+ (zbr==null?"":zbr));
			CellRangeAddress rangeAddress37 = new CellRangeAddress(rowNum+1,rowNum+1,0,5);//单位负责人
			CellRangeAddress rangeAddress38 = new CellRangeAddress(rowNum+1,rowNum+1,6,12);//科长
			CellRangeAddress rangeAddress39 = new CellRangeAddress(rowNum+1,rowNum+1,13,19);//制表人
			sheet.addMergedRegion(rangeAddress37);
			sheet.addMergedRegion(rangeAddress38);
			sheet.addMergedRegion(rangeAddress39);
		} else {//导出部分列
			HSSFSheet sheet = wb.createSheet(name);
			// 表格合并单元格的样式：参数分别为[起始行、结束行、起始列、结束列],0代表第一行或者第一列
			//不需要合并的格子不需要专门设置单元格的样式
			CellRangeAddress rangeAddress1 = new CellRangeAddress(0,0,0,18);//第一行:天津市粮食储备有限公司市级储备小麦轮换入库情况登统表
			CellRangeAddress rangeAddress2 = new CellRangeAddress(1,1,0,5);//收货单位
			CellRangeAddress rangeAddress3 = new CellRangeAddress(1,1,6,14);//填报日期
			CellRangeAddress rangeAddress4 = new CellRangeAddress(1,1,15,18);//计量单位
			CellRangeAddress rangeAddress5 = new CellRangeAddress(2,4,0,0);//序号
			CellRangeAddress rangeAddress6 = new CellRangeAddress(2,4,1,1);//车号
			CellRangeAddress rangeAddress7 = new CellRangeAddress(2,4,2,2);//仓号
			CellRangeAddress rangeAddress8 = new CellRangeAddress(2,4,3,3);//品名
			CellRangeAddress rangeAddress9 = new CellRangeAddress(2,4,4,4);//生产年度
			CellRangeAddress rangeAddress10 = new CellRangeAddress(2,4,5,5);//入库日期
			CellRangeAddress rangeAddress11 = new CellRangeAddress(2,4,6,6);//入库数量
			CellRangeAddress rangeAddress12 = new CellRangeAddress(2,2,7,15);//入库质量指标
			CellRangeAddress rangeAddress13 = new CellRangeAddress(2,4,16,16);//硬度指数
			CellRangeAddress rangeAddress14 = new CellRangeAddress(2,4,17,17);//存储方式
			CellRangeAddress rangeAddress15 = new CellRangeAddress(2,4,18,18);//备注
			CellRangeAddress rangeAddress16 = new CellRangeAddress(3,4,7,7);//等级
			CellRangeAddress rangeAddress17 = new CellRangeAddress(3,4,8,8);//容重
			CellRangeAddress rangeAddress18 = new CellRangeAddress(3,4,9,9);//不完善粒
			CellRangeAddress rangeAddress19 = new CellRangeAddress(3,3,10,13);//杂质
			CellRangeAddress rangeAddress20 = new CellRangeAddress(3,4,14,14);//水分
			CellRangeAddress rangeAddress21 = new CellRangeAddress(3,4,15,15);//色泽气味
			CellRangeAddress rangeAddress22 = new CellRangeAddress(4,4,10,10);//杂质总量
			CellRangeAddress rangeAddress23 = new CellRangeAddress(4,4,11,11);//有机杂质
			CellRangeAddress rangeAddress24 = new CellRangeAddress(4,4,12,12);//无机杂质
			CellRangeAddress rangeAddress25 = new CellRangeAddress(4,4,13,13);//筛下物

			sheet.addMergedRegion(rangeAddress1);
			sheet.addMergedRegion(rangeAddress1);
			sheet.addMergedRegion(rangeAddress2);
			sheet.addMergedRegion(rangeAddress3);
			sheet.addMergedRegion(rangeAddress4);
			sheet.addMergedRegion(rangeAddress5);
			sheet.addMergedRegion(rangeAddress6);
			sheet.addMergedRegion(rangeAddress7);
			sheet.addMergedRegion(rangeAddress8);
			sheet.addMergedRegion(rangeAddress9);
			sheet.addMergedRegion(rangeAddress10);
			sheet.addMergedRegion(rangeAddress11);
			sheet.addMergedRegion(rangeAddress12);
			sheet.addMergedRegion(rangeAddress13);
			sheet.addMergedRegion(rangeAddress14);
			sheet.addMergedRegion(rangeAddress15);
			sheet.addMergedRegion(rangeAddress16);
			sheet.addMergedRegion(rangeAddress17);
			sheet.addMergedRegion(rangeAddress18);
			sheet.addMergedRegion(rangeAddress19);
			sheet.addMergedRegion(rangeAddress20);
			sheet.addMergedRegion(rangeAddress21);
			sheet.addMergedRegion(rangeAddress22);
			sheet.addMergedRegion(rangeAddress23);
			sheet.addMergedRegion(rangeAddress24);
			sheet.addMergedRegion(rangeAddress25);

			HSSFCellStyle headStyle = wb.createCellStyle();
			HSSFFont headFont = wb.createFont();
			headFont.setFontName("黑体");
			headFont.setFontHeightInPoints((short) 18);
			headFont.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
			headStyle.setFont(headFont);
			headStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
			headStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

			HSSFCellStyle titleStyle = wb.createCellStyle();
			HSSFFont titleFont = wb.createFont();
			titleFont.setFontName("黑体");
			titleFont.setFontHeightInPoints((short) 12);
			titleStyle.setFont(titleFont);

			HSSFCellStyle contentStyle = wb.createCellStyle();
			HSSFFont contentFont = wb.createFont();
			contentFont.setFontName("黑体");
			contentFont.setFontHeightInPoints((short) 12);
			contentStyle.setFont(contentFont);
			contentStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
			contentStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
			contentStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
			contentStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);
			contentStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
			contentStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

			//第一行
			HSSFRow sheetRow = sheet.createRow(0);
			HSSFCell cell = sheetRow.createCell(0);
			cell.setCellValue("天津市粮食储备有限公司市级储备小麦轮换入库情况登统表");
			cell.setCellStyle(headStyle);

			//第二行
			HSSFRow sheetRow1 = sheet.createRow(1);
			HSSFCell cell1 = sheetRow1.createCell(0);
			HSSFCell cell2 = sheetRow1.createCell(6);
			HSSFCell cell3 = sheetRow1.createCell(15);
			cell1.setCellValue("收货单位："+ (shdw==null?"":shdw));
			cell1.setCellStyle(titleStyle);
			SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日");
			cell2.setCellValue("填报日期："+format.format(new Date()));
			cell2.setCellStyle(titleStyle);
			cell3.setCellValue("计量单位：吨（保留小数）");
			cell3.setCellStyle(titleStyle);

			//第三行：在表格的第一行设置与数据库列名对应的列的名称
			int rowNum = 2;
			HSSFRow row = sheet.createRow(rowNum);
			HSSFCell rowCell1 = row.createCell(0);
			HSSFCell rowCell2 = row.createCell(1);
			HSSFCell rowCell3 = row.createCell(2);
			HSSFCell rowCell4 = row.createCell(3);
			HSSFCell rowCell5 = row.createCell(4);
			HSSFCell rowCell6 = row.createCell(5);
			HSSFCell rowCell7 = row.createCell(6);
			HSSFCell rowCell8 = row.createCell(7);
			HSSFCell rowCell9 = row.createCell(8);
			HSSFCell rowCell10 = row.createCell(9);
			HSSFCell rowCell11 = row.createCell(10);
			HSSFCell rowCell12 = row.createCell(11);
			HSSFCell rowCell13 = row.createCell(12);
			HSSFCell rowCell14 = row.createCell(13);
			HSSFCell rowCell15 = row.createCell(14);
			HSSFCell rowCell16 = row.createCell(15);
			HSSFCell rowCell17 = row.createCell(16);
			HSSFCell rowCell18 = row.createCell(17);
			HSSFCell rowCell19 = row.createCell(18);

			rowCell1.setCellValue("序号");
			rowCell2.setCellValue("车号");
			rowCell3.setCellValue("仓号");
			rowCell4.setCellValue("品名");
			rowCell5.setCellValue("生产年度");
			rowCell6.setCellValue("入库日期");
			rowCell7.setCellValue("入库数量");
			rowCell8.setCellValue("入库质量指标");
			rowCell17.setCellValue("硬度指数H1");
			rowCell18.setCellValue("存储方式");
			rowCell19.setCellValue("备注");
			rowCell1.setCellStyle(contentStyle);
			rowCell2.setCellStyle(contentStyle);
			rowCell3.setCellStyle(contentStyle);
			rowCell4.setCellStyle(contentStyle);
			rowCell5.setCellStyle(contentStyle);
			rowCell6.setCellStyle(contentStyle);
			rowCell7.setCellStyle(contentStyle);
			rowCell8.setCellStyle(contentStyle);
			rowCell9.setCellStyle(contentStyle);
			rowCell10.setCellStyle(contentStyle);
			rowCell11.setCellStyle(contentStyle);
			rowCell12.setCellStyle(contentStyle);
			rowCell13.setCellStyle(contentStyle);
			rowCell14.setCellStyle(contentStyle);
			rowCell15.setCellStyle(contentStyle);
			rowCell16.setCellStyle(contentStyle);
			rowCell17.setCellStyle(contentStyle);
			rowCell18.setCellStyle(contentStyle);
			rowCell19.setCellStyle(contentStyle);

			rowNum+=1;//第四行
			HSSFRow row1 = sheet.createRow(rowNum);
			HSSFCell row1Cell1 = row1.createCell(0);
			HSSFCell row1Cell2 = row1.createCell(1);
			HSSFCell row1Cell3 = row1.createCell(2);
			HSSFCell row1Cell4 = row1.createCell(3);
			HSSFCell row1Cell5 = row1.createCell(4);
			HSSFCell row1Cell6 = row1.createCell(5);
			HSSFCell row1Cell7 = row1.createCell(6);
			HSSFCell row1Cell8 = row1.createCell(7);
			HSSFCell row1Cell9 = row1.createCell(8);
			HSSFCell row1Cell10 = row1.createCell(9);
			HSSFCell row1Cell11 = row1.createCell(10);
			HSSFCell row1Cell12 = row1.createCell(11);
			HSSFCell row1Cell13 = row1.createCell(12);
			HSSFCell row1Cell14 = row1.createCell(13);
			HSSFCell row1Cell15 = row1.createCell(14);
			HSSFCell row1Cell16 = row1.createCell(15);
			HSSFCell row1Cell17 = row1.createCell(16);
			HSSFCell row1Cell18 = row1.createCell(17);
			HSSFCell row1Cell19 = row1.createCell(18);

			row1Cell8.setCellValue("等级");
			row1Cell9.setCellValue("容重g/L");
			row1Cell10.setCellValue("不完善粒%");
			row1Cell11.setCellValue("杂质%");
			row1Cell15.setCellValue("水分%");
			row1Cell16.setCellValue("色泽气味");
			row1Cell1.setCellStyle(contentStyle);
			row1Cell2.setCellStyle(contentStyle);
			row1Cell3.setCellStyle(contentStyle);
			row1Cell4.setCellStyle(contentStyle);
			row1Cell5.setCellStyle(contentStyle);
			row1Cell6.setCellStyle(contentStyle);
			row1Cell7.setCellStyle(contentStyle);
			row1Cell8.setCellStyle(contentStyle);
			row1Cell9.setCellStyle(contentStyle);
			row1Cell10.setCellStyle(contentStyle);
			row1Cell11.setCellStyle(contentStyle);
			row1Cell12.setCellStyle(contentStyle);
			row1Cell13.setCellStyle(contentStyle);
			row1Cell14.setCellStyle(contentStyle);
			row1Cell15.setCellStyle(contentStyle);
			row1Cell16.setCellStyle(contentStyle);
			row1Cell17.setCellStyle(contentStyle);
			row1Cell18.setCellStyle(contentStyle);
			row1Cell19.setCellStyle(contentStyle);

			rowNum+=1;//第五行
			HSSFRow row2 = sheet.createRow(rowNum);
			HSSFCell row2Cell1 = row2.createCell(0);
			HSSFCell row2Cell2 = row2.createCell(1);
			HSSFCell row2Cell3 = row2.createCell(2);
			HSSFCell row2Cell4 = row2.createCell(3);
			HSSFCell row2Cell5 = row2.createCell(4);
			HSSFCell row2Cell6 = row2.createCell(5);
			HSSFCell row2Cell7 = row2.createCell(6);
			HSSFCell row2Cell8 = row2.createCell(7);
			HSSFCell row2Cell9 = row2.createCell(8);
			HSSFCell row2Cell10 = row2.createCell(9);
			HSSFCell row2Cell11 = row2.createCell(10);
			HSSFCell row2Cell12 = row2.createCell(11);
			HSSFCell row2Cell13 = row2.createCell(12);
			HSSFCell row2Cell14 = row2.createCell(13);
			HSSFCell row2Cell15 = row2.createCell(14);
			HSSFCell row2Cell16 = row2.createCell(15);
			HSSFCell row2Cell17 = row2.createCell(16);
			HSSFCell row2Cell18 = row2.createCell(17);
			HSSFCell row2Cell19 = row2.createCell(18);
			row2Cell11.setCellValue("总量");
			row2Cell12.setCellValue("有机杂质");
			row2Cell13.setCellValue("无机杂质");
			row2Cell14.setCellValue("筛下物%");
			row2Cell1.setCellStyle(contentStyle);
			row2Cell2.setCellStyle(contentStyle);
			row2Cell3.setCellStyle(contentStyle);
			row2Cell4.setCellStyle(contentStyle);
			row2Cell5.setCellStyle(contentStyle);
			row2Cell6.setCellStyle(contentStyle);
			row2Cell7.setCellStyle(contentStyle);
			row2Cell8.setCellStyle(contentStyle);
			row2Cell9.setCellStyle(contentStyle);
			row2Cell10.setCellStyle(contentStyle);
			row2Cell11.setCellStyle(contentStyle);
			row2Cell12.setCellStyle(contentStyle);
			row2Cell13.setCellStyle(contentStyle);
			row2Cell14.setCellStyle(contentStyle);
			row2Cell15.setCellStyle(contentStyle);
			row2Cell16.setCellStyle(contentStyle);
			row2Cell17.setCellStyle(contentStyle);
			row2Cell18.setCellStyle(contentStyle);
			row2Cell19.setCellStyle(contentStyle);

			Integer xh=1;
			double rksl = 0d;
			for(int i=0; i<list.size();i++){
				HSSFRow hssfRow = sheet.createRow(++rowNum);
				HSSFCell hssfCell1 = hssfRow.createCell(0);
				HSSFCell hssfCell2 = hssfRow.createCell(1);
				HSSFCell hssfCell3 = hssfRow.createCell(2);
				HSSFCell hssfCell4 = hssfRow.createCell(3);
				HSSFCell hssfCell5 = hssfRow.createCell(4);
				HSSFCell hssfCell6 = hssfRow.createCell(5);
				HSSFCell hssfCell7 = hssfRow.createCell(6);
				HSSFCell hssfCell8 = hssfRow.createCell(7);
				HSSFCell hssfCell9 = hssfRow.createCell(8);
				HSSFCell hssfCell10 = hssfRow.createCell(9);
				HSSFCell hssfCell11 = hssfRow.createCell(10);
				HSSFCell hssfCell12 = hssfRow.createCell(11);
				HSSFCell hssfCell13 = hssfRow.createCell(12);
				HSSFCell hssfCell14 = hssfRow.createCell(13);
				HSSFCell hssfCell15 = hssfRow.createCell(14);
				HSSFCell hssfCell16 = hssfRow.createCell(15);
				HSSFCell hssfCell17 = hssfRow.createCell(16);
				HSSFCell hssfCell18 = hssfRow.createCell(17);
				HSSFCell hssfCell19 = hssfRow.createCell(18);
				hssfCell1.setCellValue(xh);
				hssfCell2.setCellValue((String)list.get(i).get("cphm"));
				hssfCell3.setCellValue((String)list.get(i).get("cf"));
				hssfCell4.setCellValue((String)list.get(i).get("lspz"));
				hssfCell5.setCellValue((String)list.get(i).get("scnf"));
				Date date = (Date)list.get(i).get("rq");
				hssfCell6.setCellValue(format.format(date));
				rksl = Double.parseDouble(list.get(i).get("rksl").toString());
				rksl = rksl/1000;
				String rksls = rksl+"";
				rksls = ParameterUtil.decimalFormat(3, rksls, true);
				hssfCell7.setCellValue(rksls);
				//hssfCell7.setCellValue(((BigDecimal)list.get(i).get("rksl")).toString());
				hssfCell8.setCellValue((String)list.get(i).get("lsdj"));
				hssfCell9.setCellValue((String)list.get(i).get("rz"));
				hssfCell10.setCellValue((String)list.get(i).get("bwslzl"));
				hssfCell11.setCellValue((String)list.get(i).get("zzzl"));
				hssfCell12.setCellValue((String)list.get(i).get("yjzz"));
				hssfCell13.setCellValue((String)list.get(i).get("wjzz"));
				hssfCell14.setCellValue((String)list.get(i).get("sxw"));
				hssfCell15.setCellValue((String)list.get(i).get("sf"));
				hssfCell16.setCellValue((String)list.get(i).get("szqw"));
				hssfCell17.setCellValue((String)list.get(i).get("ydzs"));
				hssfCell18.setCellValue((String)list.get(i).get("ccfs"));
				hssfCell19.setCellValue("");
				hssfCell1.setCellStyle(contentStyle);
				hssfCell2.setCellStyle(contentStyle);
				hssfCell3.setCellStyle(contentStyle);
				hssfCell4.setCellStyle(contentStyle);
				hssfCell5.setCellStyle(contentStyle);
				hssfCell6.setCellStyle(contentStyle);
				hssfCell7.setCellStyle(contentStyle);
				hssfCell8.setCellStyle(contentStyle);
				hssfCell9.setCellStyle(contentStyle);
				hssfCell10.setCellStyle(contentStyle);
				hssfCell11.setCellStyle(contentStyle);
				hssfCell12.setCellStyle(contentStyle);
				hssfCell13.setCellStyle(contentStyle);
				hssfCell14.setCellStyle(contentStyle);
				hssfCell15.setCellStyle(contentStyle);
				hssfCell16.setCellStyle(contentStyle);
				hssfCell17.setCellStyle(contentStyle);
				hssfCell18.setCellStyle(contentStyle);
				hssfCell19.setCellStyle(contentStyle);
				++xh;
			}
			HSSFRow hssfRow = sheet.createRow(rowNum+1);
			hssfRow.createCell(0).setCellValue("单位负责人：" + (dwfzr==null?"":dwfzr));
			hssfRow.createCell(6).setCellValue("科长：");
			hssfRow.createCell(13).setCellValue("制表人："+ (zbr==null?"":zbr));
			CellRangeAddress rangeAddress26 = new CellRangeAddress(rowNum+1,rowNum+1,0,5);//单位负责人
			CellRangeAddress rangeAddress27 = new CellRangeAddress(rowNum+1,rowNum+1,6,12);//科长
			CellRangeAddress rangeAddress28 = new CellRangeAddress(rowNum+1,rowNum+1,13,18);//制表人
			sheet.addMergedRegion(rangeAddress26);
			sheet.addMergedRegion(rangeAddress27);
			sheet.addMergedRegion(rangeAddress28);
		}
		
		return wb;
	}

	@Override
	public HSSFWorkbook ricedataTransfor(List<Map<String, Object>> list, String zbr, String shdw, String dwfzr) {
		HSSFWorkbook wb = new HSSFWorkbook();
		String name = "稻谷";
		HSSFSheet sheet = wb.createSheet(name);
		// 起始行、结束行、起始列、结束列
		CellRangeAddress rangeAddress = new CellRangeAddress(0,0,0,18);
		CellRangeAddress rangeAddress1 = new CellRangeAddress(2,3,1,1);
		CellRangeAddress rangeAddress2 = new CellRangeAddress(2,3,2,2);
		CellRangeAddress rangeAddress3 = new CellRangeAddress(2,3,3,3);
		CellRangeAddress rangeAddress4 = new CellRangeAddress(2,3,4,4);
		CellRangeAddress rangeAddress5 = new CellRangeAddress(2,3,5,5);
		CellRangeAddress rangeAddress6 = new CellRangeAddress(2,3,6,6);
		CellRangeAddress rangeAddress7 = new CellRangeAddress(2,2,7,16);
		CellRangeAddress rangeAddress8 = new CellRangeAddress(2,3,17,17);
		CellRangeAddress rangeAddress9 = new CellRangeAddress(2,3,18,18);
		CellRangeAddress rangeAddress15 = new CellRangeAddress(1,1,0,5);
		CellRangeAddress rangeAddress16 = new CellRangeAddress(1,1,6,12);
		CellRangeAddress rangeAddress18 = new CellRangeAddress(2,3,0,0);
		CellRangeAddress rangeAddress22 = new CellRangeAddress(1,1,13,18);
		sheet.addMergedRegion(rangeAddress);
		sheet.addMergedRegion(rangeAddress1);
		sheet.addMergedRegion(rangeAddress2);
		sheet.addMergedRegion(rangeAddress3);
		sheet.addMergedRegion(rangeAddress4);
		sheet.addMergedRegion(rangeAddress5);
		sheet.addMergedRegion(rangeAddress6);
		sheet.addMergedRegion(rangeAddress7);
		sheet.addMergedRegion(rangeAddress8);
		sheet.addMergedRegion(rangeAddress9);
		sheet.addMergedRegion(rangeAddress15);
		sheet.addMergedRegion(rangeAddress16);
		sheet.addMergedRegion(rangeAddress18);
		sheet.addMergedRegion(rangeAddress22);


		HSSFCellStyle headStyle = wb.createCellStyle();
		HSSFFont headFont = wb.createFont();
		headFont.setFontName("黑体");
		headFont.setFontHeightInPoints((short) 18);
		headFont.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
		headStyle.setFont(headFont);
		headStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		headStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);


		HSSFCellStyle contentStyle = wb.createCellStyle();
		HSSFFont contentFont = wb.createFont();
		contentFont.setFontName("黑体");
		contentFont.setFontHeightInPoints((short) 12);
		contentStyle.setFont(contentFont);
		contentStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
		contentStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
		contentStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
		contentStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);
		contentStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		contentStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

		HSSFCellStyle titleStyle = wb.createCellStyle();
		HSSFFont titleFont = wb.createFont();
		titleFont.setFontName("黑体");
		titleFont.setFontHeightInPoints((short) 12);
		titleStyle.setFont(titleFont);

		HSSFRow sheetRow = sheet.createRow(0);
		HSSFCell cell = sheetRow.createCell(0);
		cell.setCellValue("天津市粮食储备有限公司市级储备稻谷轮换入库情况登统表");
		cell.setCellStyle(headStyle);
		HSSFRow sheetRow1 = sheet.createRow(1);
		HSSFCell cell1 = sheetRow1.createCell(0);
		HSSFCell cell2 = sheetRow1.createCell(6);
		HSSFCell cell3 = sheetRow1.createCell(13);
		cell1.setCellValue("收货单位："+ (shdw==null?"":shdw));
		cell1.setCellStyle(titleStyle);
		SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日");
		cell2.setCellValue("填报日期："+format.format(new Date()));
		cell2.setCellStyle(titleStyle);
		cell3.setCellValue("计量单位：吨（保留小数）");
		cell3.setCellStyle(titleStyle);
		//在表格的第一行设置与数据库列名对应的列的名称
		int rowNum = 2;
		HSSFRow row = sheet.createRow(rowNum);
		HSSFCell rowCell1 = row.createCell(0);
		rowCell1.setCellValue("序号");
		HSSFCell rowCell2 = row.createCell(1);
		rowCell2.setCellValue("车号");
		HSSFCell rowCell3 = row.createCell(2);
		rowCell3.setCellValue("仓号");
		HSSFCell rowCell4 = row.createCell(3);
		rowCell4.setCellValue("品名");
		HSSFCell rowCell5 = row.createCell(4);
		rowCell5.setCellValue("生产年度");
		HSSFCell rowCell6 = row.createCell(5);
		rowCell6.setCellValue("入库日期");
		HSSFCell rowCell7 = row.createCell(6);
		rowCell7.setCellValue("入库数量");
		HSSFCell rowCell8 = row.createCell(7);
		rowCell8.setCellValue("入库质量指标");
		HSSFCell rowCell9 = row.createCell(17);
		rowCell9.setCellValue("存储方式");
		HSSFCell rowCell10 = row.createCell(18);
		rowCell10.setCellValue("备注");
		HSSFCell rowCell11 = row.createCell(8);
		HSSFCell rowCell12 = row.createCell(9);
		HSSFCell rowCell13 = row.createCell(10);
		HSSFCell rowCell14 = row.createCell(11);
		HSSFCell rowCell15 = row.createCell(12);
		HSSFCell rowCell16 = row.createCell(13);
		HSSFCell rowCell17 = row.createCell(14);
		HSSFCell rowCell18 = row.createCell(15);
		HSSFCell rowCell19 = row.createCell(16);
		rowCell1.setCellStyle(contentStyle);
		rowCell2.setCellStyle(contentStyle);
		rowCell3.setCellStyle(contentStyle);
		rowCell4.setCellStyle(contentStyle);
		rowCell5.setCellStyle(contentStyle);
		rowCell6.setCellStyle(contentStyle);
		rowCell7.setCellStyle(contentStyle);
		rowCell8.setCellStyle(contentStyle);
		rowCell9.setCellStyle(contentStyle);
		rowCell10.setCellStyle(contentStyle);
		rowCell11.setCellStyle(contentStyle);
		rowCell12.setCellStyle(contentStyle);
		rowCell13.setCellStyle(contentStyle);
		rowCell14.setCellStyle(contentStyle);
		rowCell15.setCellStyle(contentStyle);
		rowCell16.setCellStyle(contentStyle);
		rowCell17.setCellStyle(contentStyle);
		rowCell18.setCellStyle(contentStyle);
		rowCell19.setCellStyle(contentStyle);


		rowNum+=1;
		HSSFRow row1 = sheet.createRow(rowNum);
		HSSFCell row1Cell1 = row1.createCell(7);
		HSSFCell row1Cell2 = row1.createCell(8);
		HSSFCell row1Cell3 = row1.createCell(9);
		HSSFCell row1Cell4 = row1.createCell(10);
		HSSFCell row1Cell5 = row1.createCell(11);
		HSSFCell row1Cell6 = row1.createCell(12);
		HSSFCell row1Cell7 = row1.createCell(13);
		HSSFCell row1Cell8 = row1.createCell(14);
		HSSFCell row1Cell9 = row1.createCell(15);
		HSSFCell row1Cell10 = row1.createCell(16);
		HSSFCell row1Cell11 = row1.createCell(0);
		HSSFCell row1Cell12 = row1.createCell(1);
		HSSFCell row1Cell13 = row1.createCell(2);
		HSSFCell row1Cell14 = row1.createCell(3);
		HSSFCell row1Cell15 = row1.createCell(4);
		HSSFCell row1Cell16 = row1.createCell(5);
		HSSFCell row1Cell17 = row1.createCell(6);
		HSSFCell row1Cell18 = row1.createCell(17);
		HSSFCell row1Cell19 = row1.createCell(18);
		row1Cell1.setCellValue("等级");
		row1Cell2.setCellValue("出糙率%");
		row1Cell3.setCellValue("整精米率%");
		row1Cell4.setCellValue("杂质%");
		row1Cell5.setCellValue("水分%");
		row1Cell6.setCellValue("黄粒米%");
		row1Cell7.setCellValue("谷外糙米%");
		row1Cell8.setCellValue("互混率%");
		row1Cell9.setCellValue("色泽气味%");
		row1Cell10.setCellValue("脂肪酸值KOH/干基 mg/100g");
		row1Cell1.setCellStyle(contentStyle);
		row1Cell2.setCellStyle(contentStyle);
		row1Cell3.setCellStyle(contentStyle);
		row1Cell4.setCellStyle(contentStyle);
		row1Cell5.setCellStyle(contentStyle);
		row1Cell6.setCellStyle(contentStyle);
		row1Cell7.setCellStyle(contentStyle);
		row1Cell8.setCellStyle(contentStyle);
		row1Cell9.setCellStyle(contentStyle);
		row1Cell10.setCellStyle(contentStyle);
		row1Cell11.setCellStyle(contentStyle);
		row1Cell12.setCellStyle(contentStyle);
		row1Cell13.setCellStyle(contentStyle);
		row1Cell14.setCellStyle(contentStyle);
		row1Cell15.setCellStyle(contentStyle);
		row1Cell16.setCellStyle(contentStyle);
		row1Cell17.setCellStyle(contentStyle);
		row1Cell18.setCellStyle(contentStyle);
		row1Cell19.setCellStyle(contentStyle);

		Integer xh=1;
		double rksl = 0d;
		for(int i=0; i<list.size();i++){
			HSSFRow hssfRow = sheet.createRow(++rowNum);
			HSSFCell hssfCell1 = hssfRow.createCell(0);
			HSSFCell hssfCell2 = hssfRow.createCell(1);
			HSSFCell hssfCell3 = hssfRow.createCell(2);
			HSSFCell hssfCell4 = hssfRow.createCell(3);
			HSSFCell hssfCell5 = hssfRow.createCell(4);
			HSSFCell hssfCell6 = hssfRow.createCell(5);
			HSSFCell hssfCell7 = hssfRow.createCell(6);
			HSSFCell hssfCell8 = hssfRow.createCell(7);
			HSSFCell hssfCell9 = hssfRow.createCell(8);
			HSSFCell hssfCell10 = hssfRow.createCell(9);
			HSSFCell hssfCell11 = hssfRow.createCell(10);
			HSSFCell hssfCell12 = hssfRow.createCell(11);
			HSSFCell hssfCell13 = hssfRow.createCell(12);
			HSSFCell hssfCell14 = hssfRow.createCell(13);
			HSSFCell hssfCell15 = hssfRow.createCell(14);
			HSSFCell hssfCell16 = hssfRow.createCell(15);
			HSSFCell hssfCell17 = hssfRow.createCell(16);
			HSSFCell hssfCell18 = hssfRow.createCell(17);
			HSSFCell hssfCell19 = hssfRow.createCell(18);
			hssfCell1.setCellValue(xh);
			hssfCell2.setCellValue((String)list.get(i).get("cphm"));
			hssfCell3.setCellValue((String)list.get(i).get("cf"));
			hssfCell4.setCellValue((String)list.get(i).get("lspz"));
			hssfCell5.setCellValue((String)list.get(i).get("scnf"));
			Date date = (Date)list.get(i).get("rq");
			hssfCell6.setCellValue(format.format(date));
			rksl = Double.parseDouble(list.get(i).get("rksl").toString());
			rksl = rksl/1000;
			String rksls = rksl+"";
			rksls = ParameterUtil.decimalFormat(3, rksls, true);
			hssfCell7.setCellValue(rksls);
			//hssfCell7.setCellValue(((BigDecimal)list.get(i).get("rksl")).toString());
			hssfCell8.setCellValue((String)list.get(i).get("lsdj"));
			hssfCell9.setCellValue((String)list.get(i).get("ccl"));
			hssfCell10.setCellValue((String)list.get(i).get("zjml"));
			hssfCell11.setCellValue((String)list.get(i).get("zzzl"));
			hssfCell12.setCellValue((String)list.get(i).get("sf"));
			hssfCell13.setCellValue((String)list.get(i).get("hlm"));
			hssfCell14.setCellValue((String)list.get(i).get("gwcm"));
			hssfCell15.setCellValue((String)list.get(i).get("hhl"));
			hssfCell16.setCellValue((String)list.get(i).get("szqw"));
			hssfCell18.setCellValue((String)list.get(i).get("ccfs"));
			hssfCell17.setCellValue((String)list.get(i).get("zfsz"));
			hssfCell1.setCellStyle(contentStyle);
			hssfCell2.setCellStyle(contentStyle);
			hssfCell3.setCellStyle(contentStyle);
			hssfCell4.setCellStyle(contentStyle);
			hssfCell5.setCellStyle(contentStyle);
			hssfCell6.setCellStyle(contentStyle);
			hssfCell7.setCellStyle(contentStyle);
			hssfCell8.setCellStyle(contentStyle);
			hssfCell9.setCellStyle(contentStyle);
			hssfCell10.setCellStyle(contentStyle);
			hssfCell11.setCellStyle(contentStyle);
			hssfCell12.setCellStyle(contentStyle);
			hssfCell13.setCellStyle(contentStyle);
			hssfCell14.setCellStyle(contentStyle);
			hssfCell15.setCellStyle(contentStyle);
			hssfCell16.setCellStyle(contentStyle);
			hssfCell17.setCellStyle(contentStyle);
			hssfCell18.setCellStyle(contentStyle);
			hssfCell19.setCellStyle(contentStyle);
			++xh;
		}
		HSSFRow hssfRow = sheet.createRow(rowNum+1);
		HSSFCell hssfCell1 = hssfRow.createCell(0);
		HSSFCell hssfCell2 = hssfRow.createCell(6);
		HSSFCell hssfCell3 = hssfRow.createCell(13);
		hssfCell1.setCellValue("单位负责人："+(dwfzr==null?"":dwfzr));
		hssfCell2.setCellValue("科长：");
		hssfCell3.setCellValue("制表人："+ (zbr==null?"":zbr));
		hssfCell1.setCellStyle(titleStyle);
		hssfCell2.setCellStyle(titleStyle);
		hssfCell3.setCellStyle(titleStyle);
		hssfRow.setRowStyle(titleStyle);
		CellRangeAddress rangeAddress19 = new CellRangeAddress(rowNum+1,rowNum+1,0,5);
		CellRangeAddress rangeAddress20 = new CellRangeAddress(rowNum+1,rowNum+1,6,12);
		CellRangeAddress rangeAddress21 = new CellRangeAddress(rowNum+1,rowNum+1,13,18);
		sheet.addMergedRegion(rangeAddress19);
		sheet.addMergedRegion(rangeAddress20);
		sheet.addMergedRegion(rangeAddress21);
		return wb;
	}

	@Override
	public HSSFWorkbook crudeOilTransfor(List<Map<String, Object>> list, String zbr, String shdw, String dwfzr) {
		HSSFWorkbook wb = new HSSFWorkbook();
		String name = "原油";
		HSSFSheet sheet = wb.createSheet(name);
		// 起始行、结束行、起始列、结束列
		CellRangeAddress rangeAddress = new CellRangeAddress(0,0,0,16);//第一行:天津市粮食储备有限公司市级储备原油轮换入库情况登统表
		CellRangeAddress rangeAddress1 = new CellRangeAddress(1,1,0,6);//收货单位
		CellRangeAddress rangeAddress2 = new CellRangeAddress(1,1,7,11);//填报日期
		CellRangeAddress rangeAddress3 = new CellRangeAddress(1,1,12,16);//计量单位
		CellRangeAddress rangeAddress4 = new CellRangeAddress(2,3,0,0);//序号
		CellRangeAddress rangeAddress5 = new CellRangeAddress(2,3,1,1);//车号
		CellRangeAddress rangeAddress6 = new CellRangeAddress(2,3,2,2);//油罐名称
		CellRangeAddress rangeAddress7 = new CellRangeAddress(2,3,3,3);//品名
		CellRangeAddress rangeAddress8 = new CellRangeAddress(2,3,4,4);//生产年度
		CellRangeAddress rangeAddress9 = new CellRangeAddress(2,3,5,5);//入库日期
		CellRangeAddress rangeAddress10 = new CellRangeAddress(2,3,6,6);//入库数量
		CellRangeAddress rangeAddress11 = new CellRangeAddress(3,3,7,7);//气味、滋味
		CellRangeAddress rangeAddress12 = new CellRangeAddress(3,3,8,9);//水分及挥发物含量
		CellRangeAddress rangeAddress13 = new CellRangeAddress(3,3,10,11);//不溶性杂质含量%
		CellRangeAddress rangeAddress14 = new CellRangeAddress(2,2,7,14);//入库质量标准
		CellRangeAddress rangeAddress15 = new CellRangeAddress(3,3,12,12);//酸价
		CellRangeAddress rangeAddress16 = new CellRangeAddress(3,3,13,13);//过氧化值
		CellRangeAddress rangeAddress17 = new CellRangeAddress(3,3,14,14);//溶剂残留量
		CellRangeAddress rangeAddress18 = new CellRangeAddress(2,3,15,15);//存储方式
		CellRangeAddress rangeAddress19 = new CellRangeAddress(2,3,16,16);//备注
		sheet.addMergedRegion(rangeAddress);
		sheet.addMergedRegion(rangeAddress1);
		sheet.addMergedRegion(rangeAddress2);
		sheet.addMergedRegion(rangeAddress3);
		sheet.addMergedRegion(rangeAddress4);
		sheet.addMergedRegion(rangeAddress5);
		sheet.addMergedRegion(rangeAddress6);
		sheet.addMergedRegion(rangeAddress7);
		sheet.addMergedRegion(rangeAddress8);
		sheet.addMergedRegion(rangeAddress9);
		sheet.addMergedRegion(rangeAddress10);
		sheet.addMergedRegion(rangeAddress11);
		sheet.addMergedRegion(rangeAddress12);
		sheet.addMergedRegion(rangeAddress13);
		sheet.addMergedRegion(rangeAddress14);
		sheet.addMergedRegion(rangeAddress15);
		sheet.addMergedRegion(rangeAddress16);
		sheet.addMergedRegion(rangeAddress17);
		sheet.addMergedRegion(rangeAddress18);
		sheet.addMergedRegion(rangeAddress19);

		HSSFCellStyle headStyle = wb.createCellStyle();
		HSSFFont headFont = wb.createFont();
		headFont.setFontName("黑体");
		headFont.setFontHeightInPoints((short) 18);
		headFont.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
		headStyle.setFont(headFont);
		headStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		headStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);


		HSSFCellStyle contentStyle = wb.createCellStyle();
		HSSFFont contentFont = wb.createFont();
		contentFont.setFontName("黑体");
		contentFont.setFontHeightInPoints((short) 12);
		contentStyle.setFont(contentFont);
		contentStyle.setBorderBottom(HSSFCellStyle.BORDER_THIN); //下边框
		contentStyle.setBorderLeft(HSSFCellStyle.BORDER_THIN);//左边框
		contentStyle.setBorderTop(HSSFCellStyle.BORDER_THIN);//上边框
		contentStyle.setBorderRight(HSSFCellStyle.BORDER_THIN);
		contentStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
		contentStyle.setAlignment(HSSFCellStyle.ALIGN_CENTER);

		HSSFCellStyle titleStyle = wb.createCellStyle();
		HSSFFont titleFont = wb.createFont();
		titleFont.setFontName("黑体");
		titleFont.setFontHeightInPoints((short) 12);
		titleStyle.setFont(titleFont);

		//第一行
		HSSFRow sheetRow = sheet.createRow(0);
		HSSFCell cell = sheetRow.createCell(0);
		cell.setCellValue("天津市粮食储备有限公司市级储备原油轮换入库情况登统表");
		cell.setCellStyle(headStyle);

		//第二行
		HSSFRow sheetRow1 = sheet.createRow(1);
		HSSFCell cell1 = sheetRow1.createCell(0);
		HSSFCell cell2 = sheetRow1.createCell(7);
		HSSFCell cell3 = sheetRow1.createCell(12);
		cell1.setCellValue("收货单位："+ (shdw==null?"":shdw));
		cell1.setCellStyle(titleStyle);
		SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日");
		cell2.setCellValue("填报日期："+format.format(new Date()));
		cell2.setCellStyle(titleStyle);
		cell3.setCellValue("计量单位：吨（保留小数）");
		cell3.setCellStyle(titleStyle);

		//第三行：在表格的第一行设置与数据库列名对应的列的名称
		int rowNum = 2;
		HSSFRow row = sheet.createRow(rowNum);
		HSSFCell rowCell1 = row.createCell(0);
		rowCell1.setCellValue("序号");
		HSSFCell rowCell2 = row.createCell(1);
		rowCell2.setCellValue("车号");
		HSSFCell rowCell3 = row.createCell(2);
		rowCell3.setCellValue("油罐名称");
		HSSFCell rowCell4 = row.createCell(3);
		rowCell4.setCellValue("品名");
		HSSFCell rowCell5 = row.createCell(4);
		rowCell5.setCellValue("生产年度");
		HSSFCell rowCell6 = row.createCell(5);
		rowCell6.setCellValue("入库日期");
		HSSFCell rowCell7 = row.createCell(6);
		rowCell7.setCellValue("入库数量");
		HSSFCell rowCell8 = row.createCell(7);
		rowCell8.setCellValue("入库质量指标");
		HSSFCell rowCell9 = row.createCell(15);
		rowCell9.setCellValue("存储方式");
		HSSFCell rowCell10 = row.createCell(16);
		rowCell10.setCellValue("备注");
		HSSFCell rowCell11 = row.createCell(8);
		HSSFCell rowCell12 = row.createCell(9);
		HSSFCell rowCell13 = row.createCell(10);
		HSSFCell rowCell14 = row.createCell(11);
		HSSFCell rowCell15 = row.createCell(12);
		HSSFCell rowCell16 = row.createCell(13);
		HSSFCell rowCell17 = row.createCell(14);
		rowCell1.setCellStyle(contentStyle);
		rowCell2.setCellStyle(contentStyle);
		rowCell3.setCellStyle(contentStyle);
		rowCell4.setCellStyle(contentStyle);
		rowCell5.setCellStyle(contentStyle);
		rowCell6.setCellStyle(contentStyle);
		rowCell7.setCellStyle(contentStyle);
		rowCell8.setCellStyle(contentStyle);
		rowCell9.setCellStyle(contentStyle);
		rowCell10.setCellStyle(contentStyle);
		rowCell11.setCellStyle(contentStyle);
		rowCell12.setCellStyle(contentStyle);
		rowCell13.setCellStyle(contentStyle);
		rowCell14.setCellStyle(contentStyle);
		rowCell15.setCellStyle(contentStyle);
		rowCell16.setCellStyle(contentStyle);
		rowCell17.setCellStyle(contentStyle);

		//第四行
		rowNum+=1;
		HSSFRow row1 = sheet.createRow(rowNum);
		HSSFCell row1Cell1 = row1.createCell(0);
		HSSFCell row1Cell2 = row1.createCell(1);
		HSSFCell row1Cell3 = row1.createCell(2);
		HSSFCell row1Cell4 = row1.createCell(3);
		HSSFCell row1Cell5 = row1.createCell(4);
		HSSFCell row1Cell6 = row1.createCell(5);
		HSSFCell row1Cell7 = row1.createCell(6);
		HSSFCell row1Cell8 = row1.createCell(7);
		HSSFCell row1Cell9 = row1.createCell(8);
		HSSFCell row1Cell10 = row1.createCell(9);
		HSSFCell row1Cell11 = row1.createCell(10);
		HSSFCell row1Cell12 = row1.createCell(11);
		HSSFCell row1Cell13 = row1.createCell(12);
		HSSFCell row1Cell14 = row1.createCell(13);
		HSSFCell row1Cell15 = row1.createCell(14);
		HSSFCell row1Cell16 = row1.createCell(15);
		HSSFCell row1Cell17 = row1.createCell(16);
		row1Cell8.setCellValue("气味、滋味");
		row1Cell9.setCellValue("水分及挥发物含量%");
		row1Cell11.setCellValue("不溶性杂质含量%");
		row1Cell13.setCellValue("酸价(KOH)/(mg/g)");
		row1Cell14.setCellValue("过氧化值(mmol/kg)");
		row1Cell15.setCellValue("溶剂残留量(mg/kg)");
		row1Cell1.setCellStyle(contentStyle);
		row1Cell2.setCellStyle(contentStyle);
		row1Cell3.setCellStyle(contentStyle);
		row1Cell4.setCellStyle(contentStyle);
		row1Cell5.setCellStyle(contentStyle);
		row1Cell6.setCellStyle(contentStyle);
		row1Cell7.setCellStyle(contentStyle);
		row1Cell8.setCellStyle(contentStyle);
		row1Cell9.setCellStyle(contentStyle);
		row1Cell10.setCellStyle(contentStyle);
		row1Cell11.setCellStyle(contentStyle);
		row1Cell12.setCellStyle(contentStyle);
		row1Cell13.setCellStyle(contentStyle);
		row1Cell14.setCellStyle(contentStyle);
		row1Cell15.setCellStyle(contentStyle);
		row1Cell16.setCellStyle(contentStyle);
		row1Cell17.setCellStyle(contentStyle);

		Integer xh=1;
		double rksl = 0d;
		CellRangeAddress rangeAddressData1 = null;
		CellRangeAddress rangeAddressData2 = null;
		CellRangeAddress rangeAddressData3 = null;
		CellRangeAddress rangeAddressData4 = null;
		CellRangeAddress rangeAddressData5 = null;
		CellRangeAddress rangeAddressData6 = null;
		CellRangeAddress rangeAddressData7 = null;
		CellRangeAddress rangeAddressData8 = null;
		CellRangeAddress rangeAddressData9 = null;
		CellRangeAddress rangeAddressData10 = null;
		CellRangeAddress rangeAddressData11 = null;
		CellRangeAddress rangeAddressData12 = null;
		CellRangeAddress rangeAddressData13 = null;
		CellRangeAddress rangeAddressData14 = null;
		CellRangeAddress rangeAddressData15 = null;
		for(int i=0; i<list.size();i++){
			HSSFRow hssfRow = sheet.createRow(++rowNum);
			rangeAddressData1 = new CellRangeAddress(rowNum-1,rowNum-1,0,0);//序号
			rangeAddressData2 = new CellRangeAddress(rowNum-1,rowNum-1,1,1);//车号
			rangeAddressData3 = new CellRangeAddress(rowNum-1,rowNum-1,2,2);//油罐名称
			rangeAddressData4 = new CellRangeAddress(rowNum-1,rowNum-1,3,3);//品名
			rangeAddressData5 = new CellRangeAddress(rowNum-1,rowNum-1,4,4);//生产年度
			rangeAddressData6 = new CellRangeAddress(rowNum-1,rowNum-1,5,5);//入库日期
			rangeAddressData7 = new CellRangeAddress(rowNum-1,rowNum-1,6,6);//入库数量
			rangeAddressData8 = new CellRangeAddress(rowNum-1,rowNum-1,7,7);//气味、滋味
			rangeAddressData9 = new CellRangeAddress(rowNum-1,rowNum-1,8,9);//水分及挥发物含量%
			rangeAddressData10 = new CellRangeAddress(rowNum-1,rowNum-1,10,11);//不溶性杂质含量%
			rangeAddressData11 = new CellRangeAddress(rowNum-1,rowNum-1,12,12);//酸价
			rangeAddressData12 = new CellRangeAddress(rowNum-1,rowNum-1,13,13);//过氧化值
			rangeAddressData13 = new CellRangeAddress(rowNum-1,rowNum-1,14,14);//溶剂残留量
			rangeAddressData14 = new CellRangeAddress(rowNum-1,rowNum-1,15,15);//存储方式
			rangeAddressData15 = new CellRangeAddress(rowNum-1,rowNum-1,16,16);//备注
			sheet.addMergedRegion(rangeAddressData1);
			sheet.addMergedRegion(rangeAddressData2);
			sheet.addMergedRegion(rangeAddressData3);
			sheet.addMergedRegion(rangeAddressData4);
			sheet.addMergedRegion(rangeAddressData5);
			sheet.addMergedRegion(rangeAddressData6);
			sheet.addMergedRegion(rangeAddressData7);
			sheet.addMergedRegion(rangeAddressData8);
			sheet.addMergedRegion(rangeAddressData9);
			sheet.addMergedRegion(rangeAddressData10);
			sheet.addMergedRegion(rangeAddressData11);
			sheet.addMergedRegion(rangeAddressData12);
			sheet.addMergedRegion(rangeAddressData13);
			sheet.addMergedRegion(rangeAddressData14);
			sheet.addMergedRegion(rangeAddressData15);
			HSSFCell hssfCell1 = hssfRow.createCell(0);
			HSSFCell hssfCell2 = hssfRow.createCell(1);
			HSSFCell hssfCell3 = hssfRow.createCell(2);
			HSSFCell hssfCell4 = hssfRow.createCell(3);
			HSSFCell hssfCell5 = hssfRow.createCell(4);
			HSSFCell hssfCell6 = hssfRow.createCell(5);
			HSSFCell hssfCell7 = hssfRow.createCell(6);
			HSSFCell hssfCell8 = hssfRow.createCell(7);
			HSSFCell hssfCell9 = hssfRow.createCell(8);
			HSSFCell hssfCell10 = hssfRow.createCell(9);
			HSSFCell hssfCell11 = hssfRow.createCell(10);
			HSSFCell hssfCell12 = hssfRow.createCell(11);
			HSSFCell hssfCell13 = hssfRow.createCell(12);
			HSSFCell hssfCell14 = hssfRow.createCell(13);
			HSSFCell hssfCell15 = hssfRow.createCell(14);
			HSSFCell hssfCell16 = hssfRow.createCell(15);
			HSSFCell hssfCell17 = hssfRow.createCell(16);
			hssfCell1.setCellValue(xh);
			hssfCell2.setCellValue((String)list.get(i).get("cphm"));
			hssfCell3.setCellValue((String)list.get(i).get("cf"));
			hssfCell4.setCellValue((String)list.get(i).get("lspz"));
			hssfCell5.setCellValue((String)list.get(i).get("scnf"));
			Date date = (Date)list.get(i).get("rq");
			hssfCell6.setCellValue(format.format(date));
			rksl = Double.parseDouble(list.get(i).get("rksl").toString());
			rksl = rksl/1000;
			String rksls = rksl+"";
			rksls = ParameterUtil.decimalFormat(3, rksls, true);
			hssfCell7.setCellValue(rksls);
			hssfCell8.setCellValue((String)list.get(i).get("qwzw"));
			hssfCell9.setCellValue((String)list.get(i).get("sfhfw"));
			hssfCell11.setCellValue((String)list.get(i).get("brxzz"));
			hssfCell13.setCellValue((String)list.get(i).get("sj"));
			hssfCell14.setCellValue((String)list.get(i).get("gyhz"));
			hssfCell15.setCellValue((String)list.get(i).get("rjcll"));
			hssfCell16.setCellValue((String)list.get(i).get("ccfs"));
			hssfCell17.setCellValue("");//备注
			hssfCell1.setCellStyle(contentStyle);
			hssfCell2.setCellStyle(contentStyle);
			hssfCell3.setCellStyle(contentStyle);
			hssfCell4.setCellStyle(contentStyle);
			hssfCell5.setCellStyle(contentStyle);
			hssfCell6.setCellStyle(contentStyle);
			hssfCell7.setCellStyle(contentStyle);
			hssfCell8.setCellStyle(contentStyle);
			hssfCell9.setCellStyle(contentStyle);
			hssfCell10.setCellStyle(contentStyle);
			hssfCell11.setCellStyle(contentStyle);
			hssfCell12.setCellStyle(contentStyle);
			hssfCell13.setCellStyle(contentStyle);
			hssfCell14.setCellStyle(contentStyle);
			hssfCell15.setCellStyle(contentStyle);
			hssfCell16.setCellStyle(contentStyle);
			hssfCell17.setCellStyle(contentStyle);
			++xh;
		}
		HSSFRow hssfRow = sheet.createRow(rowNum+1);
		HSSFCell hssfCell1 = hssfRow.createCell(0);
		HSSFCell hssfCell2 = hssfRow.createCell(6);
		HSSFCell hssfCell3 = hssfRow.createCell(12);
		hssfCell1.setCellValue("单位负责人："+(dwfzr==null?"":dwfzr));
		hssfCell2.setCellValue("科长：");
		hssfCell3.setCellValue("制表人："+ (zbr==null?"":zbr));
		hssfCell1.setCellStyle(titleStyle);
		hssfCell2.setCellStyle(titleStyle);
		hssfCell3.setCellStyle(titleStyle);
		hssfRow.setRowStyle(titleStyle);
		CellRangeAddress rangeAddress20 = new CellRangeAddress(rowNum+1,rowNum+1,0,5);
		CellRangeAddress rangeAddress21 = new CellRangeAddress(rowNum+1,rowNum+1,6,11);
		CellRangeAddress rangeAddress22 = new CellRangeAddress(rowNum+1,rowNum+1,12,16);
		sheet.addMergedRegion(rangeAddress20);
		sheet.addMergedRegion(rangeAddress21);
		sheet.addMergedRegion(rangeAddress22);
		return wb;
	}

}
